local L = LibStub("AceLocale-3.0"):NewLocale("GuildLotteryRaffle", "enUS", true)

local GLR_VersionText = GetAddOnMetadata("GuildLotteryRaffle", "Version")

-- Addon DEFAULT_CHAT_FRAME Translations
L["GLR Disabled Message"] = "Addon is disabled, please enable it to begin a Lottery/Raffle"
L["GLR Disabled No Guild Message"] = "You must be in a Guild to use this Addon."
L["GLR Invalid Raffle Item"] = "Invalid Raffle Item detected."

-- Addon Error/Completion Message Translations
L["No Entries"] = "Can't start event with zero entries"
L["No Entries Found"] = "No Entries Found"
L["Confirm Cancel"] = "Confirm Cancel"
L["Confirm Action"] = "Confirm Action"
L["Confirm Cancel Desc"] = "Must be checked to cancel current event"
L["Confirm Cancel False"] = "Checkbox must be ticked, confirming you wish to cancel the event."
L["Lottery Canceled Message"] = "Current Lottery Event Canceled"
L["Raffle Canceled Message"] = "Current Raffle Event Canceled"
L["GLR AddOn Loaded Msg 1"] = "Guild Lottery & Raffle AddOn Version"
L["GLR AddOn Loaded Msg 2"] = "Loaded Successfully"
L["Cant Create Calendar Events"] = "You are unable to create Guild Events. Please contact your Guild Master to correct this."
L["Calendar Events Disabled"] = "Creation of Calendar Events is disabled. Please enable it (Toggle Calendar Events) to create a Guild Calendar Event."
L["Initalization Complete"] = "Initalization Complete! Multi-Guild Roster Updated."

-- Ticket Giveaway Message Translations
L["Ticket Giveaway P1"] = "Everyone has received up to"
L["Ticket Giveaway P2.1"] = "ticket for the current"	--Tickets given away is 1
L["Ticket Giveaway P2.2"] = "tickets for the current"	--Tickets given away is greater than 1
L["Ticket Giveaway P3"] = "event"

-- Frame Title Font String Translations
L["Guild Lottery & Raffles"] = true -- Title of the mod. Set to true as it won't be translated.
L["Lottery & Raffle Info"] = "Lottery & Raffle Info" -- Lottery Info Frame Title
L["Players & their Total Tickets"] = "Players & their Total Tickets" -- Lottery Player Name Frame Title
L["Number of Unused Tickets"] = "Number of Unused Tickets" -- Unused Ticket Frame Title
L["Ticket Number Range"] = "Ticket Number Range" -- Ticket Number Range Frame Title
L["View Ticket Info Title"] = "View Player Tickets"
L["NewUpdateFrame Changes"] = "AddOn Updated"

-- Lottery & Raffle Translation
L["Lottery"] = "Lottery"
L["Raffle"] = "Raffle"
L["Both"] = "Both"

-- Detect Lottery/Raffle Msg Translation (must all be lower case characters, and have a ! before the text)
L["Detect Lottery"] = "!lottery"
L["Detect Raffle"] = "!raffle"

-- Class Name Translations
L["Death Knight"] = "Death Knight"
L["Demon Hunter"] = "Demon Hunter"
L["Druid"] = "Druid"
L["Hunter"] = "Hunter"
L["Mage"] = "Mage"
L["Monk"] = "Monk"
L["Paladin"] = "Paladin"
L["Priest"] = "Priest"
L["Rogue"] = "Rogue"
L["Shaman"] = "Shaman"
L["Warlock"] = "Warlock"
L["Warrior"] = "Warrior"

-- Month Name Translations
L["January"] = "January"
L["February"] = "February"
L["March"] = "March"
L["April"] = "April"
L["May"] = "May"
L["June"] = "June"
L["July"] = "July"
L["August"] = "August"
L["September"] = "September"
L["October"] = "October"
L["November"] = "November"
L["December"] = "December"

-- Numerical Translations (for some languages, up to 31)
L["0"] = "0"
L["00"] = "00"
L["1"] = "1"
L["01"] = "01"
L["2"] = "2"
L["02"] = "02"
L["3"] = "3"
L["03"] = "03"
L["4"] = "4"
L["04"] = "04"
L["5"] = "5"
L["05"] = "05"
L["6"] = "6"
L["06"] = "06"
L["7"] = "7"
L["07"] = "07"
L["8"] = "8"
L["08"] = "08"
L["9"] = "9"
L["09"] = "09"
L["10"] = "10"
L["11"] = "11"
L["12"] = "12"
L["13"] = "13"
L["14"] = "14"
L["15"] = "15"
L["16"] = "16"
L["17"] = "17"
L["18"] = "18"
L["19"] = "19"
L["20"] = "20"
L["21"] = "21"
L["22"] = "22"
L["23"] = "23"
L["24"] = "24"
L["25"] = "25"
L["26"] = "26"
L["27"] = "27"
L["28"] = "28"
L["29"] = "29"
L["30"] = "30"
L["31"] = "31"
L["45"] = "45" -- 45th minute out of 60 (60 = 00)
L["2018"] = "2018" --Current Year + One More year (can create calendar events up to one year ahead)
L["2019"] = "2019"

-- Calendar Guild Announcement Text Translations
L["Calendar Lottery Title"] = "Guild Lottery"
L["Calendar Raffle Title"] = "Guild Raffle"
L["Calendar Guild Announcement Part 1"] = "Tickets are"
L["Calendar Guild Announcement Part 2"] = "Gold Each"
L["Calendar Guild Announcement Part 3"] = "Tickets can be bought per person"
L["Calendar Guild Announcement Part 4"] = "Contact"
L["Calendar Guild Announcement Part 5"] = "For further details"

-- Button Font String Translations
L["New Lottery Button"] = "New Lottery"
L["New Raffle Button"] = "New Raffle"
L["Begin Lottery Button"] = "Begin Lottery"
L["Begin Raffle Button"] = "Begin Raffle"
L["Alert Guild Button"] = "Alert Guild"
L["New Player Button"] = "New Player"
L["Edit Players Button"] = "Edit Players"
L["Configure Button"] = "Configure"
L["Go To Raffle Button"] = "Go To Raffle"
L["Go To Lottery Button"] = "Go To Lottery"
L["Confirm Start Button"] = "Confirm Start"
L["Start New Lottery Button"] = "Start Lottery"
L["Start New Raffle Button"] = "Start Raffle"
L["Confirm Add Player Button"] = "Add Player"
L["Confirm Edit Player Button"] = "Edit Player"
L["Confirm Action Button"] = "Confirm"
L["Confirm Add Raffle Item"] = "Okay"
L["Abort Roll"] = "Abort Roll"
L["Confirm Abort Roll"] = "Confirm Abort"
L["Scan Mail Button"] = "Scan Mail"

-- Lottery Info Frame Font String Translations
L["Lottery Date"] = "Lottery Date"
L["Raffle Date"] = "Raffle Date"
L["Lottery Name"] = "Lottery Name"
L["Raffle Name"] = "Raffle Name"
L["Starting Gold"] = "Starting Gold"
L["Raffle First Place"] = "First Place Prize"
L["Raffle Second Place"] = "Second Place Prize"
L["Raffle Third Place"] = "Third Place Prize"
L["Raffle Sales"] = "Ticket Sales"
L["Jackpot"] = "Jackpot"
L["Raffle Second Place"] = "Second Place Prize"
L["Max Tickets"] = "Max Tickets"
L["Ticket Price"] = "Ticket Price"
L["Second Place %"] = "Second Place %"
L["Guild Cut %"] = "Guild Cut %"
L["Winner Guaranteed"] = "Winner Guaranteed"

-- New Lottery Frame Font String Translations
L["New Lottery Settings"] = "New Lottery Settings"
L["Select Valid Lottery Date"] = "Select a Valid Date for the new Lottery"
L["Hour"] = "Hour:"
L["Minute"] = "Minute:"
L["Set Lottery Name"] = "Set Lottery Name"
L["Set Starting Gold"] = "Set Starting Gold"
L["Set Maximum Tickets"] = "Set Maximum Tickets"
L["Set Ticket Price"] = "Set Ticket Price"
L["Set Second Place Prize"] = "Set Second Place Prize"
L["Set Guild Cut"] = "Set Guild Cut"

-- New Raffle Frame Font String Translations
L["New Raffle Settings"] = "New Raffle Settings"
L["Select Valid Raffle Date"] = "Select a Valid Date for the new Raffle"
L["Set Raffle Name"] = "Set Raffle Name"
L["Set First Place"] = "First Place Prize"
L["Set Second Place"] = "Second Place Prize"
L["Set Third Place"] = "Third Place Prize"

-- Add Player Frame Font String Translations (general)
L["Type Player Name"] = "Type Player Name:"
L["Add Player Tickets"] = "Add Player Tickets:"
L["Add Player Must Have Tickets"] = "Player Must Have Atleast 1 Ticket"
L["Add Player No Name Given"] = "Please Enter a Player Name"
L["Add Player They Already Exist"] = "Player Already Exists"
L["Add Player Max Tickets Exceeded"] = "Tickets Exceed Max Limit"
L["Add Player Cant Have 0 Tickets"] = "Player Can't have 0 Tickets"
L["No Player Found"] = "No Player Found"

-- Add Player to Lottery Frame Font String Translations
L["Add Player to Lottery"] = "Add Player to Lottery"

-- Add Player to Raffle Frame Font String Translations
L["Add Player to Raffle"] = "Add Player to Raffle"

-- Edit Player Frame Font String Translations
L["Edit Players in Lottery"] = "Edit Players in Lottery"
L["Edit Players in Raffle"] = "Edit Players in Raffle"
L["Select Player to Edit"] = "Select Player to Edit:"
L["Edit Player Name Below"] = "Edit Player Name Below"
L["Edit Player Tickets Below"] = "Edit Player Tickets Below"
L["Edit Player Name Exists & Max Tickets Exceeded"] = "Name Already Exists, Max Tickets Exceeded"
L["Edit Player Name Exists"] = "Name Already Exists"
L["Edit Player Max Tickets Exceeded"] = "Tickets Exceed Max Limit"
L["Edit Player Ticket Not Numerical"] = "Ticket Change Must Be Numerical"

-- New Lottery/Raffle Frame Error Message Translations
L["Guild Cut Error"] = "Guild Cut must be between 0 and 100"
L["Second Place Error"] = "Second Place must be between 0 and 100"
L["Guild & Second Place Error"] = "Total of Second Place & Guild Cut can't be higher than 100"
L["Invalid Ticket Error"] = "Invalid Ticket Price"
L["Max Ticket Error"] = "Max Tickets must be between 1 and 50000"
L["Starting Gold Error"] = "Invalid Starting Gold"
L["Lottery Name Error"] = "Please enter a name for your Lottery"
L["Month Error"] = "Please select a valid Month"
L["Day Error"] = "Please select a valid Day"
L["Hour Error"] = "Please select a valid Hour"
L["Date Error"] = "Please select a valid Date"
L["Prize Error"] = "Please enter at least one Prize"

-- Mail Scanning Error/Completion Message Translations
L["Mail Scan Start"] = "Starting Mail Scan Process"
L["Mail Scan Refreshing Mailbox"] = "Refreshing Mailbox"
L["Mail Scan Processing"] = "Processing"
L["Mail Scan Complete"] = "Mail Scanning Process Complete"
L["Mail Scan Interrupted"] = "Mail Scanning Process Interrupted, Inbox Frame Closed."
L["Mail Scan Format String 1"] = "for"
L["Mail Scan Format String 2"] = "Gold Received"
L["Mail Scan Extra Ticket String 1"] = "sent"
L["Mail Scan Extra Ticket String 2"] = "Extra Gold"
L["Mail Scan Extra Ticket String 3"] = "This amount can be sent back to them or to the Guild Bank"

-- View Player Ticket Info Frame Font String Translations
L["Ticket Info Player Name"] = "Player Name"
L["Ticket Info Player Tickets P1"] = "Purchased"
L["Ticket Info Player Tickets P2"] = "Tickets"
L["Ticket Info Gold Value P1"] = "Value"
L["Ticket Info Gold Value P2"] = "Gold"

-- Lottery/Raffle Roll Guild Text Translations
-- Initiate Lottery / Raffle Roll
L["GLR Title with Version"] = "Guild Lottery & Raffles v" -- The 'v' at the end denotes the Version of the mod
L["Begin Lottery Draw"] = "Lottery Draw will commence shortly"
L["Begin Raffle Draw"] = "Raffle Draw will commence shortly"
L["No Lottery Active"] = "No Lottery Active"
L["No Raffle Active"] = "No Raffle Active"
L["Draw In Progress"] = "Draw is in progress, please wait for it to complete."
-- Step 1
L["Lottery Draw Step 1 Part 1"] = "GLR: A total of"
L["Lottery Draw Step 1 Part 2"] = "Tickets were sold, for a total of"
L["Lottery Draw Step 1 Part 3"] = "Gold."
L["Draw Given Tickets"] = "Free Tickets were given away."
L["Raffle Draw Step 1"] = "Raffle Prize(s)"
L["Raffle Draw Step 1 Prize 1"] = "First Place Prize"
L["Raffle Draw Step 1 Prize 2"] = "Second Place Prize"
L["Raffle Draw Step 1 Prize 3"] = "Third Place Prize"
-- Step 2
L["Lottery Draw Step 2 Invalid Tickets Part 1"] = "GLR: There are: "
L["Lottery Draw Step 2 Invalid Tickets Part 2"] = " Unused Tickets. If the winning number is one of them, the Winning Ticket will be redrawn. This process may take some time."
L["Lottery Draw Step 2 Part 1"] = "GLR: Ticket Numbers ranged from"
L["Lottery Draw Step 2 Part 2"] = "to"
-- Step 3
L["Lottery Draw Step 3 Fixed Variable 1"] = "% of the Jackpot."
L["Lottery Draw Step 3 Fixed Variable 2"] = "GLR: No one is guaranteed to win the Jackpot, however no one has a chance to win a Second Place prize either."
L["Lottery Draw Step 3 Fixed Variable 3"] = "GLR: The Guild has decided not to take a percentage of the Jackpot."
L["Lottery Draw Step 3 Condition 1"] = "GLR: There's no Second Place as a winner is guaranteed! However the Guilds take is "
L["Lottery Draw Step 3 Condition 2"] = "GLR: There's no Second Place as a winner is guaranteed! The Guild has also decided not to take a percentage of the Jackpot!"
L["Lottery Draw Step 3 Condition 3 Guild Part"] = "GLR: The Guilds take is "
L["Lottery Draw Step 3 Condition 3"] = "GLR: If no one wins the Jackpot, someone has a chance to win Second Place for "
-- Step 4
L["Lottery Draw Step 4 Fixed Variable 1"] = " Gold."
L["Lottery Draw Step 4 Fixed Variable 2"] = "GLR: Since no winner is guaranteed, if no one wins the Jackpot of "
L["Lottery Draw Step 4 Fixed Variable 3"] = " Gold. Their's a chance for someone to win: "
L["Lottery Draw Step 4 Condition 1 Part 1"] = "GLR: After the Guilds take of "
L["Lottery Draw Step 4 Condition 1 Part 2"] = " Gold, the remaining Jackpot total is: "
L["Lottery Draw Step 4 Announce Roll"] = "GLR: The roll will begin in 10 seconds."
-- Step 5
L["Lottery Draw Step 5 Announce Winning Ticket"] = "GLR: The Winning Ticket number is: "
L["Raffle Draw Step 5 Announce First Ticket"] = "GLR: The First Winning Ticket number is: "
L["Raffle Draw Step 5 Announce Second Ticket"] = "GLR: The Second Winning Ticket number is: "
L["Raffle Draw Step 5 Announce Third Ticket"] = "GLR: The Third Winning Ticket number is: "
L["Lottery Draw Step 5 Winner Found Part 1"] = "GLR: A winner has been found! "
L["Lottery Draw Step 5 Winner Found Part 2"] = " is the winner, receiving "
L["Lottery Draw Step 5 Winner Found Part 3"] = " Gold."
L["Raffle Draw Step 5 Winner Found Fixed Variable"] = " is the winner, receiving "
L["Raffle Draw Step 5 First Winner Found"] = "GLR: A winner has been found for First Place! "
L["Raffle Draw Step 5 Second Winner Found"] = "GLR: A winner has been found for Second Place! "
L["Raffle Draw Step 5 Third Winner Found"] = "GLR: A winner has been found for Third Place! "
L["Lottery Draw Step 5 Guilds Take Part 1"] = "GLR: The Guild will receive: "
L["Lottery Draw Step 5 Guilds Take Part 2"] = " Gold."
L["Lottery Draw Step 5 Unused Ticket Found Part 1"] = "GLR: The winning ticket number was "
L["Lottery Draw Step 5 Unused Ticket Found Part 2"] = " and matched a Unused Ticket Number, redrawing a new winning ticket number."
L["Lottery Draw Step 5 Unused Ticket Redraw"] = "GLR: Redraw will start in 10 seconds."
L["Lottery Draw Step 5 No Winner Found"] = "GLR: No winner could be found for: "
L["Lottery Draw Step 5 Draw Second Place"] = "GLR: Draw for Second Place will start in 10 seconds."
-- Step 6
L["Lottery Draw Step 6 Announce Second Place Winning Ticket"] = "GLR: The winning ticket number for Second Place is: "
L["Lottery Draw Step 6 Winner Found Part 1"] = "GLR: A Second Place Winner has been found! "
L["Lottery Draw Step 6 Winner Found Part 2"] = " will receive "
L["Lottery Draw Step 6 Winner Found Part 3"] = " Gold."
L["Lottery Draw Step 6 Guilds Take Part 1"] = "GLR: The Guild will receive: "
L["Lottery Draw Step 6 Guilds Take Part 2"] = " Gold."
L["Lottery Draw Step 6 Next Lottery Starts Part 1"] = "GLR: The next lottery will start with at least "
L["Lottery Draw Step 6 Next Lottery Starts Part 2"] = " Gold."
L["Lottery Draw Step 6 Unused Ticket Found Part 1"] = "GLR: The winning ticket number was "
L["Lottery Draw Step 6 Unused Ticket Found Part 2"] = " and matched a Unused Ticket Number, redrawing a new winning ticket number."
L["Lottery Draw Step 6 Unused Ticket Redraw"] = "GLR: Redraw will start in 10 seconds."
L["Lottery Draw Step 6 No Winner Found"] = "GLR: The Second Place winning ticket number was: "
L["Lottery Draw Step 6 No Second Place Part 1"] = "GLR: No winner was found for Second Place. The next lottery will start with at least "
L["Lottery Draw Step 6 No Second Place Part 2"] = " Gold."
-- Lottery/Raffle Completed Message
L["Lottery Draw Complete"] = "GLR: Lottery Draw Completed."
L["Raffle Draw Complete"] = "GLR: Raffle Draw Completed."

-- Abort Roll Message
L["Abort Roll Message"] = "GLR: Draw Process Aborted."

-- Alert Guild Translations
L["Alert Guild GLR Title"] = "Guild Lottery & Raffle v" .. GLR_VersionText -- The 'v' is to denote the version of the mod
L["Alert Guild Lottery Scheduled"] = "A Lottery is scheduled for"
L["Alert Guild Raffle Scheduled"] = "A Raffle is scheduled for"
L["Alert Guild LaR Scheduled"] = "A Lottery and Raffle are scheduled for"
L["Alert Guild Event Name"] = "Event Name"
L["Alert Guild Ticket Info Part 1"] = "Tickets are"
L["Alert Guild Ticket Info Part 2"] = "gold each."
L["Alert Guild Ticket Info Part 3"] = "A maximum of"
L["Alert Guild Ticket Info Part 4"] = "tickets can be bought per person."
L["Alert Guild Tickets Bought Part 1"] = "The jackpot is currently"
L["Alert Guild Tickets Bought Part 2"] = "Gold."
L["Alert Guild Raffle Tickets Bought"] = "Raffle Tickets have been bought."
L["Alert Guild Whisper For Lottery Info"] = "Whisper '!lottery' for more details."
L["Alert Guild Whisper For Raffle Info"] = "Whisper '!raffle' for more details."
L["Alert Guild Whisper For LaR Info"] = "Whisper '!lottery' for more Lottery details. Whisper '!raffle' for more Raffle details."
L["Alert Guild Time Between Alerts Part 1"] = "Please wait at least "
L["Alert Guild Time Between Alerts Part 2"] = " seconds before sending another alert."
L["Alert Guild No Lottery Active"] = "No Lottery is currently set."
L["Alert Guild No Raffle Active"] = "No Raffle is currently set."
L["Alert Guild No LoR Active"] = "No Lottery or Raffle is currently set."

-- Send Player Ticket Info Translations
L["Send Info Title"] = "Guild Lottery & Raffle v" .. GLR_VersionText
L["Send Info Event Info 1"] = "Event Info For"
L["Send Info Event Info 2"] = "on"
L["Send Info Player Lottery Entered"] = "You've entered into a Lottery scheduled for"
L["Send Info Player Raffle Entered"] = "You've entered into a Raffle scheduled for"
L["Send Info No Tickets Purchased Part 1"] = "You've not purchased any Tickets for"
L["Send Info No Tickets Purchased Part 2"] = "If this is a mistake please let me know."
L["Send Info Can Purchase Tickets Part 1"] = "You are able to purchase"
L["Send Info Can Purchase Tickets Part 2"] = "Tickets at"
L["Send Info Can Purchase Tickets Part 3"] = "Gold per Ticket."
L["Send Info Reply Lottery"] = "To see info about your purchased tickets please message me with 'lottery' after you've been entered."
L["Send Info Reply Raffle"] = "To see info about your purchased tickets please message me with 'raffle' after you've been entered."
L["Send Info Tickets Purchased First Msg 1"] = "You've purchased"
L["Send Info Tickets Purchased First Msg 2"] = "out of the"
L["Send Info Tickets Purchased First Msg 3"] = "Ticket Limit"
L["Send Info Tickets Purchased Part 1"] = "You've purchased"
L["Send Info Tickets Purchased Part 2"] = "Tickets, and can purchase"
L["Send Info Tickets Purchased Part 3"] = "additional Tickets at"
L["Send Info Tickets Purchased Part 3.1"] = "additional Ticket at"
L["Send Info Tickets Purchased Part 4"] = "gold per Ticket."
L["Send Info Max Tickets Part 1"] = "You've purchased the maximum of"
L["Send Info Max Tickets Part 2"] = "Tickets."
L["Send Info Long Ticket Message"] = "Your Ticket numbers are (long message):"
L["Send Info GLR"] = "GLR"
L["Send Info Current Jackpot Part 1"] = "After the Guilds cut of"
L["Send Info Current Jackpot Part 2"] = "The current Jackpot is"
L["Send Info Current Jackpot Part 3"] = "Gold."
L["Send Info Current Prizes"] = "The Current Raffle Prize(s) are"
L["Send Info Short Ticket Message"] = "Your Ticket Numbers are"
L["Send Info Ticket Number Range Part 1"] = "Your tickets range from"
L["Send Info Ticket Number Range Part 2"] = "to"
L["Send Info Player Online"] = "Received Ticket Information"
L["Send Info Player Not Online"] = "is not online. They will be messaged the next time you're both online."
L["Send Info No Active Lottery"] = "No Lottery is currently active."
L["Send Info No Active Raffle"] = "No Raffle is currently active."
L["Send Info Must Wait 1"] = "You must wait at least"
L["Send Info Must Wait 2"] = "seconds between receiving Guild Lottery & Raffle Info messages."
L["Send Info GLR Disabled"] = "Guild Lottery and Raffles is currently disabled."

-- Tooltip Translation
L["GLR Tooltip Title"] = "Guild Lottery & Raffle" -- Title used in all tooltips

-- New Lottery Button Tooltip Translations
L["Start New Lottery Button Tooltip"] = "Start a new Lottery"
L["Start New Lottery Button Tooltip Warning"] = "WARNING: This action will cancel any current Lottery"

-- Begin Lottery Button Tooltip Translation
L["Begin Lottery Button Tooltip"] = "Do you want to start the Lottery Draw?"

-- Alert Guild Button Tooltip Translation
L["Alert Guild Button Tooltip"] = "Alert your Guild about current Lottery/Raffle Events"

-- Add Player Button Tooltip Translation
L["Add Player Button Tooltip"] = "Add a name to the "

-- Edit Player Button Tooltip Translation
L["Edit Player Button Tooltip"] = "Edit current list of Players in the "

-- New Raffle Button Tooltip Translations
L["Start New Raffle Button Tooltip"] = "Start a new Raffle"
L["Start New Raffle Button Tooltip Warning"] = "WARNING: This action will cancel any current Raffle"

-- Begin Raffle Button Tooltip Translation
L["Begin Raffle Button Tooltip"] = "Do you want to start the Raffle Draw?"

-- Open Interface Options Button Tooltip Translation
L["Configure Button Tooltip"] = "Configure settings for Guild Lottery & Raffles AddOn"

-- Confirm Start Lottery Button Tooltip Translations
L["Confirm Start Lottery Button Tooltip"] = "Sure you want to start this Lottery?"
L["Confirm Start Lottery Button Tooltip Warning"] = "WARNING: Their's no turning back after this."

-- Confirm Start Raffle Button Tooltip Translations
L["Confirm Start Raffle Button Tooltip"] = "Sure you want to start this Raffle?"
L["Confirm Start Raffle Button Tooltip Warning"] = "WARNING: Their's no turning back after this."

-- Start New Lottery Button Tooltip Translation
L["Start Lottery Button Tooltip"] = "Confirm new Lottery Settings"

-- Start New Raffle Button Tooltip Translation
L["Start Raffle Button Tooltip"] = "Confirm new Raffle Settings"

-- Confirm Add Player Button Tooltip Translation
L["Confirm Add Player to Lottery Button Tooltip"] = "Confirm add new Player to Lottery"
L["Confirm Add Player to Raffle Button Tooltip"] = "Confirm add new Player to Raffle"

-- Confirm Edit Player Button Tooltip Translations
L["Confirm Edit Player Button Tooltip Part 1"] = "Confirm edit of "
L["Confirm Edit Player Button Tooltip Part 2"] = " in Lottery"
L["Confirm Edit Player Button Tooltip Part 3"] = " in Raffle"

-- Confirm New Lottery Button Tooltip Translations
L["Confirm New Lottery Button Tooltip"] = "Confirm start of New Lottery?"
L["Confirm New Lottery Button Tooltip Warning"] = "WARNING: This action will cancel any current Lottery"

-- Confirm New Raffle Button Tooltip Translations
L["Confirm New Raffle Button Tooltip"] = "Confirm Start of New Raffle"
L["Confirm New Raffle Button Tooltip Warning"] = "WARNING: This action will cancel anny current Raffle"

-- Abort Roll Process Button Tooltip Translation
L["Abort Roll Process Button Tooltip"] = "Abort the current Lottery/Raffle Draw"
L["Abort Roll Process Button Tooltip Warning"] = "Confirmation Required"

-- Confirm Abort Roll Process Button Tooltip Translation
L["Confirm Abort Roll Process Button Tooltip"] = "Confirm you want to stop the current Lottery/Raffle Draw"

-- Scan Mail Button Tooltip Translations
L["Scan Mail Button Tooltip"] = "Scans your mail for potential Lottery or Raffle entries. Click to start this process."
L["Scan Mail Button Tooltip Subject Line"] = "Subject lines must be" .. ' "Lottery" ' .. "or" .. ' "Raffle" ' .. "for their respective Events."
L["Scan Mail Button Tooltip Warning"] = "WARNING: For this to work properly, you must keep the mailbox open until it's complete."

-- Lottery Donation Translations
L["Donation Button"] = "Donation"
L["Donation Description Text"] = "Enter Amount To Increase Jackpot"
L["Lottery Donation Tooltip"] = "Increase the size of the current Jackpot"
L["Lottery Donation Confirmation Button Tooltip 1"] = "Increase the current Lottery Jackpot by"
L["Lottery Donation Confirmation Button Tooltip 2"] = "Gold."
L["Lottery Donation Confirmation Button Tooltip Warning"] = "WARNING: This action can't be undone, the Jackpot can't be decreased using this."
L["Send Donation Info To Guild 1"] = "The Lottery Jackpot has been increased by"
L["Send Donation Info To Guild 2"] = "Gold. The Jackpot is now"
L["Send Donation Info To Guild 3"] = "Gold."

-- Check Button Translations
L["Guarantee Winner Check Button"] = "Guarantee a Winner"
L["Allow Invalid Item Check Button"] = "Allow Invalid Items"

-- Check Button Tooltip Translations
L["Guarantee Winner Check Button Tooltip"] = "Guarantee a Winner for this Lottery event"
L["Allow Invalid Item Check Button Tooltip"] = "Allows items the mod detects as invalid to be entered"

-- Main Frame Edit Box Tooltip Translations
L["Starting Gold Edit Box Tooltip"] = "Value is in Gold, not Silver or Copper"
L["Max Tickets Edit Box Tooltip"] = "Maximum tickets a player can get"
L["Gold Value Edit Box Tooltip"] = "Value is in Gold, not Silver or Copper"
L["Second Place Percent Edit Box Tooltip"] = "Percentage of the Jackpot for Second Place"
L["Guild Cut Percent Edit Box Tooltip"] = "Percentage of the Jackpot your Guild receives"
L["Ticket Sales Edit Box Tooltip"] = "Displays the amount of Gold earned through ticket sales"

-- New Lottery Frame Edit Box Tooltip Translations
L["Set Lottery Name"] = "Set the Name of the new Lottery"
L["Set Starting Gold Part 1"] = "Set the Starting Gold for the new Lottery"
L["Set Starting Gold Part 2"] = "This gold comes from you or your Guild"
L["Set Starting Gold Part 3"] = "Previous Lottery Gold is factored after the fact!"
L["Set Maximum Lottery Tickets"] = "Set the Maximum Tickets for the new Lottery"
L["Set Lottery Ticket Price"] = "Set the Ticket Price (in Gold) for the new Lottery"
L["Set Second Place Percent"] = "Set the Second Place prize for the new Lottery"
L["Set Guild Cut Percent"] = "Set the Guild Cut for the new Lottery"
L["Set Lottery Percent Value"] = "Value is a percentage of the Jackpot, so 100 will equal 100%"

-- New Raffle Frame Edit Box Tooltip Translations
L["Set Raffle Name"] = "Set the Name of the new Raffle"
L["Set Maximum Raffle Tickets"] = "Set the Maximum Tickets for the new Raffle"
L["Set Raffle Ticket Price"] = "Set the Ticket Price (in Gold) for the new Raffle"
L["Set Raffle Prize"] = "Shift + Left-Click on the item to enter it into the Raffle."
L["Set Raffle First Place Prize"] = "This will become the item for the first place winner."
L["Set Raffle Second Place Prize P1"] = "This will become the item for the second place winner."
L["Set Raffle Second Place Prize P2"] = "Leave blank to not have a second place."
L["Set Raffle Third Place Prize P1"] = "This will become the item for the third place winner."
L["Set Raffle Third Place Prize P2"] = "Leave blank to not have a third place."

-- Add Player to Lottery Frame Edit Box Tooltip Translations
L["Add Lottery Player Name Part 1"] = "Set the Name of Player to add to the new Lottery"
L["Add Lottery Player Name Part 2"] = "Names are case sensitive, as the mod sends a message"
L["Add Lottery Player Name Part 3"] = "to the player about their Ticket Info"
L["Add Lottery Player Tickets"] = "Set the Number of Tickets Purchased for the new Lottery"

-- Edit Player in Lottery/Raffle Frame Edit Box Tooltip Translations
L["Edit Lottery Selected Player"] = "Edit the Selected Players Name"
L["Edit Lottery Selected Player Tickets"] = "Edit the Selected Players Tickets, can't be above Max Tickets"

-- Add Player to Raffle Frame Edit Box Tooltip Translations
L["Add Raffle Player Name Part 1"] = "Set the Name of Player to add to the new Raffle"
L["Add Raffle Player Name Part 2"] = "Names are case sensitive, as the mod sends a message"
L["Add Raffle Player Name Part 3"] = "to the player about their Ticket Info"
L["Add Raffle Player Tickets"] = "Set the Number of Tickets Purchased for the new Raffle"

--Donation Frame Edit Box Tooltip Translations
L["Donation Edit Box Tooltip"] = "Enter an amount to increase the current Lottery Jackpot"

-- Minimap Button Tooltip Translations
L["Minimap Button Left Click"] = "Left Click"
L["Minimap Button Left Click Info"] = "Opens Guild Lottery & Raffles"
L["Minimap Button Right Click"] = "Right Click"
L["Minimap Button Right Click Info"] = "Opens to Configuration Panel"
L["Minimap Button Hold Left"] = "Hold Left Click"
L["Minimap Button Hold Left Info"] = "Drags the Minimap Icon."

-- Configuration Panel Translations
L["Configuration Panel Information Tab"] = "Information"
L["Configuration Panel Options Tab"] = "Options"
L["Configuration Panel Options Tab Config"] = "Config"
L["Configuration Panel Options Tab General"] = "General"
L["Configuration Panel Options Tab Minimap"] = "Minimap"
L["Configuration Panel Options Tab Multi-Guild"] = "Multi-Guild"
L["Configuration Panel Events Tab"] = "Events"
L["Configuration Panel Profiles Tab"] = "Profiles"
L["Configuration Panel Preview"] = "Preview"
L["Configuration Panel Message Tab"] = "Messages"
L["Configuration Panel Message Preview"] = "Message Preview"
L["Configuration Panel Message Settings"] = "Settings"
L["Configuration Panel Message Settings Desc"] = "Configure the messages sent"
L["Configuration Panel Message Tab Guild Alert (L) Config"] = "Guild Alerts - Lottery"
L["Configuration Panel Message Tab Guild Alert (R) Config"] = "Guild Alerts - Raffle"
L["Configuration Panel Message Tab Guild Alert (B) Config"] = "Guild Alerts - Both"
L["Configuration Panel Message Tab Guild Alert (L) Name"] = "Guild Alert Messages - Lottery"
L["Configuration Panel Message Tab Guild Alert (R) Name"] = "Guild Alert Messages - Raffle"
L["Configuration Panel Message Tab Guild Alert (B) Name"] = "Guild Alert Messages - Both Events Active"
L["Configuration Panel Message Enable Lottery"] = "Enable Custom Guild Alerts for Lottery Events"
L["Configuration Panel Message Enable Raffle"] = "Enable Custom Guild Alerts for Raffle Events"
L["Configuration Panel Message Enable Both"] = "Enable Custom Guild Alerts while Both Event types are Active"
L["Configuration Panel Message Enable Both Desc"] = "Both Custom Guild Alerts for Lottery and Raffle must be Enabled for this to Enable"
L["Configuration Panel Message Tab Formats Lottery"] = "Available Formats:\n  %lottery_price -> Becomes the Ticket Cost for your Event.\n  %lottery_max -> Becomes the Maximum Tickets for your Event.\n  %lottery_name -> Becomes the Name of your Event.\n  %lottery_date -> Becomes the Date for your Event.\n  %lottery_gold -> Becomes the Jackpot for your Event.\n  %lottery_tickets -> Becomes the number of Tickets Sold.\n  %lottery_reply -> Becomes the detection phrase."
L["Configuration Panel Message Tab Formats Raffle"] = "Available Formats:\n  %raffle_price -> Becomes the Ticket Cost for your Event.\n  %raffle_max -> Becomes the Maximum Tickets for your Event.\n  %raffle_name -> Becomes the Name of your Event.\n  %raffle_date -> Becomes the Date for your Event.\n  %raffle_gold -> Becomes the Tickets Sold for your Event.\n  %raffle_reply -> Becomes the detection phrase."
L["Configuration Panel Message Too Long"] = "Warning - Custom Message can't be more than 255 characters!"
L["Configuration Panel Message One"] = "First Message"
L["Configuration Panel Message Two"] = "Second Message"
L["Configuration Panel Message Three"] = "Third Message"
L["Configuration Panel Message Four"] = "Fourth Message"
L["Configuration Panel Message Five"] = "Fifth Message"
L["Configuration Panel Message Six"] = "Sixth Message"
L["Configuration Panel Message Seven"] = "Seventh Message"
L["Configuration Panel Message Eight"] = "Eighth Message"
L["Configuration Panel Message Nine"] = "Ninth Message"
L["Configuration Panel Message Ten"] = "Tenth Message"
L["Configuration Panel Message Eleven"] = "Eleventh Message"
L["Configuration Panel Message Profile Copy Lottery Desc"] = "Copy a existing Lottery Message Profile"
L["Configuration Panel Message Profile Copy Raffle Desc"] = "Copy a existing Raffle Message Profile"
L["Configuration Panel Message Profile Copy Both Desc"] = "Copy a existing Lottery & Raffle Message Profile"

L["Configuration Panel Options Tab Ticket Info"] = "Tickets"
L["Configuration Panel Options Tab Changelog"] = "Changelog"
L["Configuration Panel Mod Author"] = "Mod Author:"
L["Configuration Panel Previous Authors"] = "Previous Mod Authors:"
L["Configuration Panel Translators"] = "Translators:"
L["Configuration Panel Toggle GLR"] = "Enable/Disable this AddOn"
L["Configuration Panel Toggle GLR Description"] = "Toggles either On/Off the Guild Lottery & Raffles AddOn."
L["Configuration Panel Slash Command List"] = "List of Slash Commands"
L["Configuration Panel How To Header"] = "How To Guide"
L["Configuration Panel How To Step 1 P1"] = "Step 1"
L["Configuration Panel How To Step 1 P2"] = "To start a Lottery or Raffle, first open the Guild Lottery & Raffles User Interface. (see above)"
L["Configuration Panel How To Step 2 P1"] = "Step 2"
L["Configuration Panel How To Step 2 P2"] = "If you want to start a Lottery click the New Lottery button and enter in the Lottery Settings. To start a Raffle click the 'Go To Raffle' button and click the New Raffle Button there and do the same."
L["Configuration Panel How To Step 3 P1"] = "Step 3"
L["Configuration Panel How To Step 3 P2"] = "To Add Players to the active Lottery click the New Player button, to edit Players in the Lottery click the Edit Players button. To Add or Edit Players in a Raffle, you must first click the 'Go To Raffle' button."
L["Configuration Panel How To Step 4 P1"] = "Step 4"
L["Configuration Panel How To Step 4 P2"] = "To start the roll process for a Lottery click the Begin Lottery button, this will ask to confirm that you wish to start the Lottery. Doing so will prevent Adding or Editing Players to the Lottery until the draw is complete. To start the same process for a Raffle, click the 'Go To Raffle' button and click the Begin Raffle button."
L["Configuration Panel Open GLR Command"] = "Opens the Guild Lottery & Raffles User Interface."
L["Configuration Panel Help Command"] = "Brings you to this interface."
L["Configuration Panel Config Command"] = "Brings you to the Options panel for Guild Lottery & Raffles."
L["Configuration Panel Options Header"] = "Options for Guild Lottery & Raffles"
L["Configuration Panel General Options Header"] = "General Settings"
L["Configuration Panel Options Minimap Header"] = "Minimap Settings"
L["Configuration Panel Options Lottery Header"] = "Lottery Settings"
L["Configuration Panel Options Guild Header"] = "Multi-Guild Settings"
L["Configuration Panel Options Raffle Header"] = "Raffle Settings"
L["Configuration Panel Options Open GLR Button"] = "Open Guild Lottery & Raffles"
L["Configuration Panel Options Open GLR Button Desc"] = "Opens the Guild Lottery & Raffles User Interface"
L["Configuration Panel Options Toggle Escape Key"] = "Toggle Escape Key"
L["Configuration Panel Options Toggle Escape Key Desc"] = "Allows the Escape Key to close the User Interface. Defaults to On"
L["Configuration Panel Options Toggle Chat Info"] = "Toggle Chat Info"
L["Configuration Panel Options Toggle Chat Info Desc"] = "Toggles On/Off extra information that's sent to your chat frame. Such as detailed Mail Scanning process."
L["Configuration Panel Options Toggle Full Ticket Info"] = "Toggle Full Ticket Info"
L["Configuration Panel Options Toggle Full Ticket Info Desc"] = "If enabled, the mod will send players their ticket info over multiple messages. If disabled the mod will just tell players their ticket number range. Defaults to disabled as lotteries with massive Max Ticket can get spammy."
L["Configuration Panel Options Time Between Alerts"] = "Set the time (in seconds) the mod will let you send alerts to your guild"
L["Configuration Panel Options Time Between Alerts Desc"] = "Used to prevent misuse of Alerts sent by the mod, ranges from 30 seconds to 10 minutes (time is in seconds). Defaults to 60 seconds. This also affects the time that players can receive Lottery info either by whispering you or typing 'lottery' in guild chat."
L["Configuration Panel Options Toggle Multi Guild"] = "Multi-Guild Events"
L["Configuration Panel Options Toggle Multi Guild Desc"] = "If enabled on two or more of your Characters, the mod will treat those Guilds as one large Super-Guild. Allowing you to add players from different Guilds. Useful for Guilds supporting more than 1K Members. Requires a Reload for settings to take affect."
L["Configuration Panel Options Toggle Multi Guild Failed"] = "Multi-Guild status can't be changed while a Lottery or Raffle is currently active. Please Complete or Cancel those events to un/link."
L["Configuration Panel Options Toggle Multi Guild Failed Other Toon"] = "has a active event."
L["Configuration Panel Options Toggle Cross Faction"] = "Cross-Faction Events"
L["Configuration Panel Options Toggle Cross Faction Desc"] = "With Multi-Guild Events enabled, this option allows you to link your Events across both Factions. Only needs to be set on the character that's hosting."
L["Configuration Panel Options Toggle Cross Faction Failed"] = "Cross-Faction status can't be changed while a Lottery or Raffle is currently active. Please Complete or Cancel those events before changing this."
L["Configuration Panel Options Toggle Calendar Events"] = "Create Calendar Events"
L["Configuration Panel Options Toggle Calendar Events Desc"] = "If enabled, the mod will create Guild Announcements for your Lottery or Raffle Events. Requires the Guild permission: 'Is Officer'"
L["Configuration Panel Options Minimap Toggle"] = "Toggles display of Minimap Icon."
L["Configuration Panel Options Minimap Toggle Desc"] = "When enabled, allows you to quickly access Guild Lottery & Raffles"
L["Configuration Panel Options Minimap X Range"] = "Manually set the X axis value for the Minimap Icon"
L["Configuration Panel Options Minimap X Range Desc"] = "Allows you to fine tune the placement of the Minimap Icon"
L["Configuration Panel Options Minimap Y Range"] = "Manually set the Y axis value for the Minimap Icon"
L["Configuration Panel Options Minimap Y Range Desc"] = "Allows you to fine tune the placement of the Minimap Icon"
L["Configuration Panel Options Cancel Lottery"] = "Cancel Lottery"
L["Configuration Panel Options Cancel Lottery Desc"] = "Cancels the current Lottery, and wipes any saved Lottery data. Confirmation Required."
L["Configuration Panel Options Profile Header"] = "Profile Settings"
L["Configuration Panel Options Profile Desc"] = "Here you can set values for the AddOn to remember when making new events in the future. You can change these settings whenever you like."
L["Configuration Panel Options Profile Copy"] = "Copy Profile"
L["Configuration Panel Options Profile Copy Lottery Desc"] = "Copy a existing Lottery Profile"
L["Configuration Panel Options Profile Copy Raffle Desc"] = "Copy a existing Raffle Profile"
L["Configuration Panel Options Profile Max Tickets"] = "Max Tickets"
L["Configuration Panel Options Profile Enter Amount Desc"] = "Enter a amount for the AddOn to remember to start all future Events with."
L["Configuration Panel Options Profile Ticket Price"] = "Ticket Price"
L["Configuration Panel Options Lottery Profile Starting Gold"] = "Starting Gold"
L["Configuration Panel Options Lottery Profile Second Place"] = "Second Place"
L["Configuration Panel Options Lottery Profile Guild Cut"] = "Guild Cut"
L["Configuration Panel Options Lottery Profile Guarantee Winner"] = "Guarantee Winner"
L["Configuration Panel Options Lottery Profile Toggle Desc"] = "Set if the AddOn should remember to Guarantee a Winner for future Lotteries."
L["Configuration Panel Options Cancel Raffle"] = "Cancel Raffle"
L["Configuration Panel Options Cancel Raffle Desc"] = "Cancels the current Raffle, and wipes any saved Raffle data. Confirmation Required."
L["Configuration Panel Options Raffle Profile Invalid Items"] = "Invalid Items"
L["Configuration Panel Options Raffle Profile Toggle Desc"] = "Set if the AddOn should remember to allow Invalid Items to be entered when creating future Raffles."
L["Configuration Panel Options Allow Multiple Raffle Winners"] = "Allow Multiple Raffle Winners"
L["Configuration Panel Options Allow Multiple Raffle Winners Desc"] = "Changes how the Raffle selects winners. If enabled then the mod will select a different winner for each prize. If disabled then one person can end up winning all prizes."
L["Configuration Panel Options Multi-Guild Description"] = "To begin the process of linking Multiple Guilds together you must enable the 'Multi-Guild Events' option in General Settings. This must be done on at least two characters in different Guilds to set their status as Linked. To host a Lottery or Raffle for the Linked Guilds, you must host it on a character you've Linked."
L["Configuration Panel Options Multi-Guild Tooltip"] = "Requires a reload to confirm status change. Can't be changed while a Lottery or Raffle event is active."
L["Configuration Panel Options Multi-Guild Linked Guilds"] = "Currently Linked Guilds"
L["Configuration Panel Options Multi-Guild Linked Characters"] = "Currently Linked Characters"
L["Configuration Panel Ticket Info Header"] = "Ticket Info for Guild Lottery & Raffles"
L["Configuration Panel Ticket Info Select Lottery Player"] = "Select Lottery Player"
L["Configuration Panel Ticket Info Select Lottery Player Desc"] = "Select a player in the current Lottery to view their Ticket Info"
L["Configuration Panel Ticket Info Select Raffle Player"] = "Select Raffle Player"
L["Configuration Panel Ticket Info Select Raffle Player Desc"] = "Select a player in the current Raffle to view their Ticket Info"
L["Configuration Panel Ticket Info Lottery Button"] = "View Lottery Player"
L["Configuration Panel Ticket Info Lottery Button Desc"] = "Views Info about the selected Lottery Entry"
L["Configuration Panel Ticket Info Raffle Button"] = "View Raffle Player"
L["Configuration Panel Ticket Info Raffle Button Desc"] = "Views Info about the selected Raffle Entry"
L["Configuration Panel Changelog Header"] = "Changelog for Guild Lottery & Raffles" -- Full changelog won't be translated into other languages as that'd take too much time, so just giving the option to translate the header.