local L = LibStub("AceLocale-3.0"):GetLocale("GuildLotteryRaffle")
if not L then return end

local firstPrize
local secondPrize
local thirdPrize
local firstWinningTicket
local secondWinningTicket
local thirdWinningTicket
local rp1 = false
local rp2 = false
local rp3 = false
local rp1t = ""
local rp2t = ""
local rp3t = ""
local raffleCompleted = false
local lotteryCompleted = false
local AnnounceRaffleFirst = false
local AnnounceRaffleSecond = false
local AnnounceRaffleThird = false
local AnnouncingWinners = false
local abortPrinted = false
local raffleTicketNumbersTable = {}
local raffleWinners = {}
local locale = GetLocale()
local lotteryWinnerFound = false
local clearPreviousJackpot = false
local remainingJackpot = 0
local FullPlayerName = (GetUnitName("PLAYER", false) .. "-" .. string.gsub(string.gsub(GetRealmName(), "-", ""), "%s+", ""))

local function GenerateTicket(firstTicket, lastTicket, arg)
	local fT = tonumber(firstTicket)
	local lT = tonumber(lastTicket)
	local ticketNumber = tostring(math.random(fT, lT))
	local ta = {}
	local breakOut = false
	local doBreak = false
	local taCount = 0
	local count = lT * 20
	local state = arg
	if glrCharacter[state].TicketPool ~= nil then
		for t, v in pairs(glrCharacter[state].TicketPool) do
			table.insert(ta, v)
			taCount = taCount + 1
		end
	end
	for i = 1, count do
		for j = 1, #ta do
			if ta[j] == ticketNumber then
				ticketNumber = tostring(math.random(fT, lT))
			end
		end
		for v = 1, #ta do
			if ta[v] ~= ticketNumber then
				doBreak = true
			elseif ta[v] == ticketNumber then
				doBreak = false
				ticketNumber = tostring(math.random(fT, lT))
			end
			if doBreak then
				break
			end
		end
		if taCount == 0 then
			doBreak = true
		end
		if doBreak then
			breakOut = true
			break
		end
	end
	if breakOut then
		return ticketNumber
	end
end

local function PrepareNextLottery()
	
	local text = date()
	local dateTime = string.sub(text, 1, string.find(text, " ") - 1)
	local EventStatus = false
	
	if glrCharacter.Data.Settings.CurrentlyActiveRaffle then --Checks if a Raffle is currently Active before confirming that both Lottery/Raffle's are inactive, allowing you to change Multi-Guild status on your character (assuming no other events are active on other characters)
		EventStatus = true
	end
	
	GLR_UI.GLR_MainFrame.GLR_AbortRollProcessButton:Hide()
	
	if not clearPreviousJackpot then
		glrCharacter.Data.Settings.PreviousLottery.TicketsSold = glrCharacter.Event.Lottery.TicketsSold
		glrCharacter.Data.Settings.PreviousLottery.TicketPrice = tonumber(glrCharacter.Event.Lottery.TicketPrice)
		glrCharacter.Data.Settings.PreviousLottery.Jackpot = tonumber(remainingJackpot)
	elseif clearPreviousJackpot then
		glrCharacter.Data.Settings.PreviousLottery.TicketsSold = 0
		glrCharacter.Data.Settings.PreviousLottery.TicketPrice = 0
		glrCharacter.Data.Settings.PreviousLottery.Jackpot = 0
	end
	
	glrCharacter.Data.Defaults.LotteryDate = dateTime
	
	local startingGold = tostring(glrCharacter.Data.Settings.PreviousLottery.Jackpot)
	local jackpotGold = startingGold
	
	GLR_UI.GLR_LotteryInfo.GLR_LotteryDateEditBox:SetText("")
	GLR_UI.GLR_LotteryInfo.GLR_LotteryNameEditBox:SetText(L["No Lottery Active"])
	GLR_UI.GLR_LotteryInfo.GLR_LotteryNameEditBox:SetCursorPosition(0)
	GLR_UI.GLR_LotteryInfo.GLR_StartingGoldEditBox:SetText(startingGold)
	GLR_UI.GLR_LotteryInfo.GLR_JackpotEditBox:SetText(jackpotGold)
	GLR_UI.GLR_LotteryInfo.GLR_MaxTicketsEditBox:SetText(glrCharacter.Data.Defaults.LotteryMaxTickets)
	GLR_UI.GLR_LotteryInfo.GLR_TicketPriceEditBox:SetText(glrCharacter.Data.Defaults.TicketPrice)
	GLR_UI.GLR_LotteryInfo.GLR_SecondPlaceEditBox:SetText(glrCharacter.Data.Defaults.SecondCut)
	GLR_UI.GLR_LotteryInfo.GLR_GuildCutEditBox:SetText(glrCharacter.Data.Defaults.GuildCut)
	GLR_UI.GLR_MainFrame.GLR_TicketNumberRangeBorderLow:SetText("0")
	GLR_UI.GLR_MainFrame.GLR_TicketNumberRangeBorderHigh:SetText("0")
	
	glrCharacter.Event.Lottery = nil
	glrCharacter.Event.Lottery = {}
	
	glrCharacter.Lottery.TicketPool = nil
	glrCharacter.Lottery.TicketPool = {}
	
	glrCharacter.Lottery.Entries.TicketRange = nil
	glrCharacter.Lottery.Entries.TicketRange = {}
	
	glrCharacter.Lottery.Entries.TicketNumbers = nil
	glrCharacter.Lottery.Entries.TicketNumbers = {}
	
	glrCharacter.Lottery.Entries.Tickets = nil
	glrCharacter.Lottery.Entries.Tickets = {}
	
	glrCharacter.Lottery.Entries.Names = nil
	glrCharacter.Lottery.Entries.Names = {}
	
	glrCharacter.Lottery.MessageStatus = nil
	glrCharacter.Lottery.MessageStatus = {}
	
	glrTemp.Lottery = nil
	glrTemp.Lottery = {}
	
	glrTempStatus = nil
	glrTempStatus = {}
	
	if glrHistory.ActiveEvents == nil then
		glrHistory.ActiveEvents = {}
	end
	
	if glrHistory.ActiveEvents[FullPlayerName] == nil then
		glrHistory.ActiveEvents[FullPlayerName] = EventStatus
	else
		glrHistory.ActiveEvents[FullPlayerName] = EventStatus
	end
	
	GLR:UpdatePlayersAndTotalTickets()
	GLR:UpdateNumberOfUnusedTickets()
	
	glrCharacter.Data.Settings.CurrentlyActiveLottery = false
	
	glrLotteryDrawInProgress = false
	
	SendChatMessage(L["Lottery Draw Complete"], "GUILD")
	
end

local function PrepareNextRaffle()
	
	local dateTime = string.sub(date(), 1, string.find(date(), " ") - 1)
	local EventStatus = false
	
	if glrCharacter.Data.Settings.CurrentlyActiveLottery then --Checks if a Raffle is currently Active before confirming that both Lottery/Raffle's are inactive, allowing you to change Multi-Guild status on your character (assuming no other events are active on other characters)
		EventStatus = true
	end
	
	GLR_UI.GLR_MainFrame.GLR_AbortRollProcessButton:Hide()
	
	glrCharacter.Data.Defaults.LotteryDate = dateTime
	
	GLR_UI.GLR_RaffleInfo.GLR_RaffleDateEditBox:SetText("")
	GLR_UI.GLR_RaffleInfo.GLR_RaffleNameEditBox:SetText(L["No Raffle Active"])
	GLR_UI.GLR_RaffleInfo.GLR_RaffleNameEditBox:SetCursorPosition(0)
	GLR_UI.GLR_RaffleInfo.GLR_RaffleMaxTicketsEditBox:SetText(glrCharacter.Data.Defaults.RaffleMaxTickets)
	GLR_UI.GLR_RaffleInfo.GLR_RaffleTicketPriceEditBox:SetText(glrCharacter.Data.Defaults.TicketPrice)
	GLR_UI.GLR_RaffleInfo.GLR_RaffleFirstPlacePrizeEditBox:SetText("")
	GLR_UI.GLR_RaffleInfo.GLR_RaffleSecondPlacePrizeEditBox:SetText("")
	GLR_UI.GLR_RaffleInfo.GLR_RaffleThirdPlacePrizeEditBox:SetText("")
	GLR_UI.GLR_MainFrame.GLR_TicketNumberRangeBorderLow:SetText("0")
	GLR_UI.GLR_MainFrame.GLR_TicketNumberRangeBorderHigh:SetText("0")
	
	glrCharacter.Data.Raffle.FirstPrizeData = nil
	glrCharacter.Data.Raffle.FirstPrizeData = {}
	glrCharacter.Data.Raffle.FirstPrizeData.ItemLink = {}
	glrCharacter.Data.Raffle.FirstPrizeData.ItemName = {}
	
	glrCharacter.Data.Raffle.SecondPrizeData = nil
	glrCharacter.Data.Raffle.SecondPrizeData = {}
	glrCharacter.Data.Raffle.SecondPrizeData.ItemLink = {}
	glrCharacter.Data.Raffle.SecondPrizeData.ItemName = {}
	
	glrCharacter.Data.Raffle.ThirdPrizeData = nil
	glrCharacter.Data.Raffle.ThirdPrizeData = {}
	glrCharacter.Data.Raffle.ThirdPrizeData.ItemName = {}
	glrCharacter.Data.Raffle.ThirdPrizeData.ItemLink = {}
	
	glrCharacter.Event.Raffle = nil
	glrCharacter.Event.Raffle = {}
	
	glrCharacter.Raffle.TicketPool = nil
	glrCharacter.Raffle.TicketPool = {}
	
	glrCharacter.Raffle.Entries.TicketRange = nil
	glrCharacter.Raffle.Entries.TicketRange = {}
	
	glrCharacter.Raffle.Entries.TicketNumbers = nil
	glrCharacter.Raffle.Entries.TicketNumbers = {}
	
	glrCharacter.Raffle.Entries.Tickets = nil
	glrCharacter.Raffle.Entries.Tickets = {}
	
	glrCharacter.Raffle.Entries.Names = nil
	glrCharacter.Raffle.Entries.Names = {}
	
	glrCharacter.Raffle.MessageStatus = nil
	glrCharacter.Raffle.MessageStatus = {}
	
	glrTemp.Raffle = nil
	glrTemp.Raffle = {}
	
	glrTempStatus = nil
	glrTempStatus = {}
	
	if glrHistory.ActiveEvents == nil then
		glrHistory.ActiveEvents = {}
	end
	
	if glrHistory.ActiveEvents[FullPlayerName] == nil then
		glrHistory.ActiveEvents[FullPlayerName] = EventStatus
	else
		glrHistory.ActiveEvents[FullPlayerName] = EventStatus
	end
	
	GLR:UpdatePlayersAndTotalTickets()
	GLR:UpdateNumberOfUnusedTickets()
	
	glrCharacter.Data.Settings.CurrentlyActiveRaffle = false
	
	glrRaffleDrawInProgress = false
	
	C_Timer.After(1, function(self) SendChatMessage(L["Raffle Draw Complete"], "GUILD") end)
	
end

--------------------------------------------- ---------
-------------- STARTS THE RAFFLE ------------
---------------------------------------------
--------- STARTS RAFFLE, EVEN BEFORE --------
------------ THE SET RAFFLE DATE ------------
---------------------------------------------

local function AnnounceRaffleWinners()
	AnnouncingWinners = true
	if not AnnounceRaffleFirst then
		--C_Timer.After(5, function(self) SendChatMessage("Test", "GUILD") end)
		C_Timer.After(0.5, function(self) SendChatMessage(L["Raffle Draw Step 5 Announce First Ticket"] .. firstWinningTicket, "GUILD") end)
		C_Timer.After(1, function(self) SendChatMessage(L["Raffle Draw Step 5 First Winner Found"] .. rp1t .. L["Raffle Draw Step 5 Winner Found Fixed Variable"] .. firstPrize, "GUILD") end)
		C_Timer.After(1.5, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
		C_Timer.After(7, AnnounceRaffleWinners)
		AnnounceRaffleFirst = true
		return
	elseif not AnnounceRaffleSecond then
		if glrCharacter.Event.Raffle.SecondPlace ~= false then
			C_Timer.After(0.5, function(self) SendChatMessage(L["Raffle Draw Step 5 Announce Second Ticket"] .. secondWinningTicket, "GUILD") end)
			C_Timer.After(1, function(self) SendChatMessage(L["Raffle Draw Step 5 Second Winner Found"] .. rp2t .. L["Raffle Draw Step 5 Winner Found Fixed Variable"] .. secondPrize, "GUILD") end)
			C_Timer.After(1.5, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
		end
		C_Timer.After(7, AnnounceRaffleWinners)
		AnnounceRaffleSecond = true
		return
	elseif not AnnounceRaffleThird then
		if glrCharacter.Event.Raffle.ThirdPlace ~= false then
			C_Timer.After(0.5, function(self) SendChatMessage(L["Raffle Draw Step 5 Announce Third Ticket"] .. thirdWinningTicket, "GUILD") end)
			C_Timer.After(1, function(self) SendChatMessage(L["Raffle Draw Step 5 Third Winner Found"] .. rp3t .. L["Raffle Draw Step 5 Winner Found Fixed Variable"] .. thirdPrize, "GUILD") end)
			C_Timer.After(1.5, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
		end
		raffleCompleted = true
		AnnounceRaffleThird = true
	end
end

local function RaffleDrawThirdPlace()
	
	local firstTicket = glrCharacter.Event.Raffle.FirstTicketNumber
	local lastTicket = glrCharacter.Event.Raffle.LastTicketBought - 1
	local thirdFound = false
	local prepareNext = false
	local doStep = glrCharacter.Data.Settings.AllowMultipleRaffleWinners
	local continue = true
	local count = 0
	
	for i = 1, #glrCharacter.Raffle.Entries.Names do
		count = count + 1
		if count == 4 then --Don't want to use up too much processing power if their are a lot of entries.
			break
		end
	end
	
	if glrCharacter.Event.Raffle.ThirdPlace ~= false then
		if rp1 and rp2 then
			for i = 1, #raffleTicketNumbersTable do
				if raffleTicketNumbersTable[i] == thirdWinningTicket then
					for t, v in pairs(glrCharacter.Raffle.Entries.Names) do
						for j = 1, #glrCharacter.Raffle.Entries.TicketNumbers[v] do
							
							local tn = glrCharacter.Raffle.Entries.TicketNumbers[v][j]
							
							if tn == thirdWinningTicket then
								
								if count >= 3 and doStep then
									for k = 1, #raffleWinners do
										if raffleWinners[k] == v then
											continue = false
										end
									end
								end
								
								if not glrAbortRoll and continue then
									--SendChatMessage(L["Raffle Draw Step 5 Announce Third Ticket"] .. thirdWinningTicket, "GUILD")
									--SendChatMessage(L["Raffle Draw Step 5 Third Winner Found"] .. v .. L["Raffle Draw Step 5 Winner Found Fixed Variable"] .. thirdPrize, "GUILD")
									--SendChatMessage("--------------------------------------------------", "GUILD")
									rp3t = v
									thirdFound = true
									prepareNext = true
									rp3 = true
									break
								elseif glrAbortRoll and not abortPrinted then
									C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
									glrRaffleDrawInProgress = false
									abortPrinted = true
								end
								
							end
						end
						
						if thirdFound or not continue then
							break
						end
						
					end
				end
				
				if thirdFound or not continue then
					break
				end
				
			end
		end
		
	elseif glrCharacter.Event.Raffle.thirdPlace == false then
		thirdFound = true
		prepareNext = true
		rp3 = true
	end
	
	if not thirdFound then
		if not glrAbortRoll then
			if rp1 and rp2 then --Prevents redrawing a different ticket number while searching for a first and second place winner.
				thirdWinningTicket = GenerateTicket(firstTicket, lastTicket, "Raffle")
			end
			C_Timer.After(1, RaffleDrawThirdPlace)
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrRaffleDrawInProgress = false
			abortPrinted = true
		end
	end
	
	if thirdFound and prepareNext then
		if not glrAbortRoll then
			local value3 = "true"
			return value3
		elseif glrAbortRoll and not abortPrinted then
			SendChatMessage(L["Abort Roll Message"], "GUILD")
			glrRaffleDrawInProgress = false
			abortPrinted = true
		end
	end
	
end

local function RaffleDrawSecondPlace()
	
	local firstTicket = glrCharacter.Event.Raffle.FirstTicketNumber
	local lastTicket = glrCharacter.Event.Raffle.LastTicketBought - 1
	local secondFound = false
	local prepareNext = false
	local doStep = glrCharacter.Data.Settings.AllowMultipleRaffleWinners
	local continue = true
	local count = 0
	
	for i = 1, #glrCharacter.Raffle.Entries.Names do
		count = count + 1
		if count == 3 then --Don't want to use up too much processing power if their are a lot of entries.
			break
		end
	end
	
	if glrCharacter.Event.Raffle.SecondPlace ~= false then
		if rp1 then
			for i = 1, #raffleTicketNumbersTable do
				if raffleTicketNumbersTable[i] == secondWinningTicket then
					for t, v in pairs(glrCharacter.Raffle.Entries.Names) do
						for j = 1, #glrCharacter.Raffle.Entries.TicketNumbers[v] do
							local tn = glrCharacter.Raffle.Entries.TicketNumbers[v][j]
							
							if tn == secondWinningTicket then
								
								if count >= 2 and doStep then
									for k = 1, #raffleWinners do
										if raffleWinners[k] == v then
											continue = false
										end
									end
								end
								
								if not glrAbortRoll and continue then
									--SendChatMessage(L["Raffle Draw Step 5 Announce Second Ticket"] .. secondWinningTicket, "GUILD")
									--SendChatMessage(L["Raffle Draw Step 5 Second Winner Found"] .. v .. L["Raffle Draw Step 5 Winner Found Fixed Variable"] .. secondPrize, "GUILD")
									--SendChatMessage("--------------------------------------------------", "GUILD")
									rp2t = v
									table.insert(raffleWinners, v)
									secondFound = true
									prepareNext = true
									rp2 = true
									break
								elseif glrAbortRoll and not abortPrinted then
									C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
									glrRaffleDrawInProgress = false
									abortPrinted = true
								end
								
							end
						end
						
						if secondFound or not continue then
							break
						end
						
					end
				end
				
				if secondFound or not continue then
					break
				end
				
			end
		end
		
	elseif glrCharacter.Event.Raffle.SecondPlace == false then
		secondFound = true
		prepareNext = true
		rp2 = true
	end
	
	if not secondFound then
		if not glrAbortRoll then
			if rp1 then --Prevents redrawing a different ticket number while searching for a first place winner.
				secondWinningTicket = GenerateTicket(firstTicket, lastTicket, "Raffle")
			end
			C_Timer.After(1, RaffleDrawSecondPlace)
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrRaffleDrawInProgress = false
			abortPrinted = true
		end
	end
	
	if secondFound and prepareNext then
		if not glrAbortRoll then
			local value2 = "true"
			return value2
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrRaffleDrawInProgress = false
			abortPrinted = true
		end
	end
	
end

local function RaffleDrawFirstPlace()
	
	local firstTicket = glrCharacter.Event.Raffle.FirstTicketNumber
	local lastTicket = glrCharacter.Event.Raffle.LastTicketBought - 1
	local firstFound = false
	local prepareNext = false
	
	for i = 1, #raffleTicketNumbersTable do
		if raffleTicketNumbersTable[i] == firstWinningTicket then
			for t, v in pairs(glrCharacter.Raffle.Entries.Names) do
				for j = 1, #glrCharacter.Raffle.Entries.TicketNumbers[v] do
					
					local tn = glrCharacter.Raffle.Entries.TicketNumbers[v][j]
					
					if tn == firstWinningTicket then
						
						if not glrAbortRoll then
							--SendChatMessage(L["Raffle Draw Step 5 Announce First Ticket"] .. firstWinningTicket, "GUILD")
							--SendChatMessage(L["Raffle Draw Step 5 First Winner Found"] .. v .. L["Raffle Draw Step 5 Winner Found Fixed Variable"] .. firstPrize, "GUILD")
							--SendChatMessage("--------------------------------------------------", "GUILD")
							rp1t = v
							table.insert(raffleWinners, v)
							firstFound = true
							prepareNext = true
							rp1 = true
							break
						elseif glrAbortRoll and not abortPrinted then
							C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
							glrRaffleDrawInProgress = false
							abortPrinted = true
						end
						
					end
				end
				
				if firstFound then
					break
				end
				
			end
		end
		
		if firstFound then
			break
		end
		
	end
	
	if not firstFound then
		if not glrAbortRoll then
			firstWinningTicket = GenerateTicket(firstTicket, lastTicket, "Raffle")
			C_Timer.After(1, RaffleDrawFirstPlace)
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrRaffleDrawInProgress = false
			abortPrinted = true
		end
	end
	
	if firstFound and prepareNext then
		if not glrAbortRoll then
			local value1 = "true"
			return value1
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrRaffleDrawInProgress = false
			abortPrinted = true
		end
	end
	
end

local function RaffleCompletionBuffer() --Acts as a buffer while the Mod searches for winning ticket numbers before erasing the raffle data.
	
	if rp1 then
		if rp2 then
			if rp3 then
				if not glrAbortRoll then
					if not AnnouncingWinners then
						AnnounceRaffleWinners()
					end
					if not raffleCompleted then
						C_Timer.After(5, RaffleCompletionBuffer)
					end
				end
			end
		end
	end
	
	if not rp1 or not rp2 or not rp3 then
		if not raffleCompleted then
			if not glrAbortRoll then
				C_Timer.After(5, RaffleCompletionBuffer)
			end
		end
	end
	
	if raffleCompleted then
		if not glrAbortRoll then
			C_Timer.After(5, PrepareNextRaffle)
		end
	end
	
end

local function RaffleStep4Buffer()
	
	if rp1 and rp2 and rp3 then
		RaffleCompletionBuffer()
	else
		C_Timer.After(5, RaffleStep4Buffer)
	end
	
end

local function BeginRaffleDrawStep4()
	
	local firstTicket = glrCharacter.Event.Raffle.FirstTicketNumber
	local lastTicket = glrCharacter.Event.Raffle.LastTicketBought - 1
	local count = glrCharacter.Event.Raffle.LastTicketBought * 10
	local continue = false
	raffleTicketNumbersTable = {} --Clears the table in case another Raffle Roll is started before someone does a /reload
	firstPrize = glrCharacter.Event.Raffle.FirstPlace
	secondPrize = false
	thirdPrize = false
	firstWinningTicket = GenerateTicket(firstTicket, lastTicket, "Raffle")
	secondWinningTicket = GenerateTicket(firstTicket, lastTicket, "Raffle")
	thirdWinningTicket = GenerateTicket(firstTicket, lastTicket, "Raffle")
	
	if glrCharacter.Event.Raffle.SecondPlace ~= false then
		secondPrize = glrCharacter.Event.Raffle.SecondPlace
	else
		rp2 = true
	end
	if glrCharacter.Event.Raffle.ThirdPlace ~= false then
		thirdPrize = glrCharacter.Event.Raffle.ThirdPlace
	else
		rp3 = true
	end
	
	for t, v in pairs(glrCharacter.Raffle.Entries.Names) do
		for i = 1, #glrCharacter.Raffle.Entries.TicketNumbers[v] do
			table.insert(raffleTicketNumbersTable, glrCharacter.Raffle.Entries.TicketNumbers[v][i])
		end
	end
	
	sort(raffleTicketNumbersTable)
	
	if not glrAbortRoll then
		
		local value1 = RaffleDrawFirstPlace()
		local value2 = "true"
		local value3 = "true"
		
		if glrCharacter.Event.Raffle.SecondPlace ~= false then
			value2 = RaffleDrawSecondPlace()
		end
		if glrCharacter.Event.Raffle.ThirdPlace ~= false then
			value3 = RaffleDrawThirdPlace()
		end
		
		RaffleStep4Buffer()
		
	elseif glrAbortRoll and not abortPrinted then
		
		C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
		glrRaffleDrawInProgress = false
		abortPrinted = true
		
	end
	
end

local function BeginRaffleDrawStep3()
	
	if not glrAbortRoll then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 4 Announce Roll"], "GUILD") end)
		C_Timer.After(0.4, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
		C_Timer.After(12, BeginRaffleDrawStep4)
	elseif glrAbortRoll and not abortPrinted then
		C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
		glrRaffleDrawInProgress = false
		abortPrinted = true
	end
	
end

local function BeginRaffleDrawStep2()
	
	local ticketPool = {}
	local numberOfInvalidTickets = 0
	local lowestTicketNumber = glrCharacter.Event.Raffle.FirstTicketNumber
	local highestTicketNumber = glrCharacter.Event.Raffle.LastTicketBought - 1
	
	if glrCharacter.Raffle.TicketPool ~= nil then
		for t, v in pairs(glrCharacter.Raffle.TicketPool) do
			numberOfInvalidTickets = numberOfInvalidTickets + 1
		end
	end
	
	if numberOfInvalidTickets > 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 2 Invalid Tickets Part 1"] .. numberOfInvalidTickets .. L["Lottery Draw Step 2 Invalid Tickets Part 2"], "GUILD") end)
		C_Timer.After(0.4, function(self) SendChatMessage(L["Lottery Draw Step 2 Part 1"] .. ": " .. lowestTicketNumber .. " " .. L["Lottery Draw Step 2 Part 2"] .. " " .. highestTicketNumber .. ".", "GUILD") end)
	else
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 2 Part 1"] .. ": " .. lowestTicketNumber .. " " .. L["Lottery Draw Step 2 Part 2"] .. " " .. highestTicketNumber .. ".", "GUILD") end)
	end
	
	if not glrAbortRoll then
		C_Timer.After(12, BeginRaffleDrawStep3)
	elseif glrAbortRoll and not abortPrinted then
		C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
		glrRaffleDrawInProgress = false
		abortPrinted = true
	end
	
end

local function BeginRaffleDrawStep1()
	
	local jackpotGold = tostring(glrCharacter.Event["Raffle"]["TicketsSold"] * tonumber(glrCharacter.Event["Raffle"]["TicketPrice"]))
	local numberOfTickets = glrCharacter.Event.Raffle.TicketsSold
	local firstPrize = glrCharacter.Event.Raffle.FirstPlace
	local secondPrize = false
	local thirdPrize = false
	
	if glrCharacter.Event.Raffle.SecondPlace ~= false then
		secondPrize = glrCharacter.Event.Raffle.SecondPlace
	end
	if glrCharacter.Event.Raffle.ThirdPlace ~= false then
		thirdPrize = glrCharacter.Event.Raffle.ThirdPlace
	end
	
	C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 1 Part 1"] .. " " .. numberOfTickets .. " " .. L["Lottery Draw Step 1 Part 2"] .. ": " .. jackpotGold .. " " .. L["Lottery Draw Step 1 Part 3"], "GUILD") end)
	
	if glrCharacter.Event.Raffle.GiveAwayTickets ~= nil then
		if glrCharacter.Event.Raffle.GiveAwayTickets > 0 then
			local GivenTickets = tostring(glrCharacter.Event.Raffle.GiveAwayTickets)
			C_Timer.After(0.4, function(self) SendChatMessage(L["Send Info GLR"] .. ": " .. GivenTickets .. " " .. L["Draw Given Tickets"], "GUILD") end)
		end
	end
	
	C_Timer.After(0.6, function(self) SendChatMessage(L["Raffle Draw Step 1"] .. ":", "GUILD") end)
	C_Timer.After(0.8, function(self) SendChatMessage(L["Raffle Draw Step 1 Prize 1"] .. ": " .. firstPrize, "GUILD") end)
	
	if secondPrize ~= false then
		C_Timer.After(1, function(self) SendChatMessage(L["Raffle Draw Step 1 Prize 2"] .. ": " .. secondPrize, "GUILD") end)
	end
	if thirdPrize ~= false then
		C_Timer.After(1.2, function(self) SendChatMessage(L["Raffle Draw Step 1 Prize 3"] .. ": " .. thirdPrize, "GUILD") end)
	end
	
	if not glrAbortRoll then
		C_Timer.After(12, BeginRaffleDrawStep2)
	elseif glrAbortRoll and not abortPrinted then
		C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
		glrRaffleDrawInProgress = false
		abortPrinted = true
	end
	
end

local function InitiateRaffleRoll()
	
	local raffleStatus = glrCharacter.Data.Settings.CurrentlyActiveRaffle
	rp1 = false
	rp2 = false
	rp3 = false
	rp1t = ""
	rp2t = ""
	rp3t = ""
	AnnounceRaffleFirst = false
	AnnounceRaffleSecond = false
	AnnounceRaffleThird = false
	AnnouncingWinners = false
	raffleCompleted = false
	glrAbortRoll = false
	abortPrinted = false
	raffleWinners = {} --Resets the table if entries exist
	
	if raffleStatus and glrCharacter.Event.Raffle ~= nil then --Prevents starting a non-existent raffle draw
		if glrCharacter.Event.Raffle.TicketsSold >= 1 then
			
			GLR_UI.GLR_MainFrame.GLR_AbortRollProcessButton:Show()
			
			if not glrAbortRoll then
				glrRaffleDrawInProgress = true --Prevents a raffle draw from occuring while one's in progress
				C_Timer.After(0.2, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
				C_Timer.After(0.4, function(self) SendChatMessage(L["GLR Title with Version"] .. GLR_Version, "GUILD") end)
				C_Timer.After(0.6, function(self) SendChatMessage(L["Begin Raffle Draw"], "GUILD") end)
				C_Timer.After(0.8, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
				C_Timer.After(15, BeginRaffleDrawStep1)
			elseif glrAbortRoll and not abortPrinted then
				C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
				glrRaffleDrawInProgress = false
				abortPrinted = true
			end
			
		end
		
	else
		GLR:Print(L["No Raffle Active"])
	end
	
end

--------------------------------------------- ---------
------------- STARTS THE LOTTERY ------------
---------------------------------------------
-------- STARTS LOTTERY, EVEN BEFORE --------
----------- THE SET LOTTERY DATE ------------
---------------------------------------------

local function LotteryCompletionBuffer() --Acts as a buffer while the Mod searches for winning ticket numbers before erasing the lottery data.
	
	if lotteryWinnerFound then
		if not glrAbortRoll then
			lotteryCompleted = true
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrLotteryDrawInProgress = false
			abortPrinted = true
		end
	end
	
	if not lotteryWinnerFound then
		if not lotteryCompleted then
			if not glrAbortRoll then
				C_Timer.After(5, LotteryCompletionBuffer)
			elseif glrAbortRoll and not abortPrinted then
				C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
				glrLotteryDrawInProgress = false
				abortPrinted = true
			end
		end
	end
	
	if lotteryCompleted then
		if not glrAbortRoll then
			C_Timer.After(7, PrepareNextLottery)
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrLotteryDrawInProgress = false
			abortPrinted = true
		end
	end
	
end

local function BeginLotteryDrawStep6() --Only does this step if no winner is guaranteed and no one won first place.
	
	local firstTicket = glrCharacter.Event.Lottery.FirstTicketNumber
	local lastTicket = glrCharacter.Event.Lottery.LastTicketBought - 1
	local winningTicket = tostring(math.random(firstTicket, lastTicket))
	local jackpotGold = tonumber(glrCharacter.Event["Lottery"]["StartingGold"]) + ( glrCharacter.Event["Lottery"]["TicketsSold"] * tonumber(glrCharacter.Event["Lottery"]["TicketPrice"]) )
	local guildPercent = (tonumber(glrCharacter.Event.Lottery.GuildCut) / 100) * jackpotGold
	local secondPercent = (tonumber(glrCharacter.Event.Lottery.SecondPlace) / 100) * jackpotGold
	local ticketNumbersTable = {}
	local ticketPool = {}
	local winnerFound = false
	local prepareNext = false
	remainingJackpot = remainingJackpot - secondPercent
	
	for t, v in pairs(glrCharacter.Lottery.Entries.Names) do
		for i = 1, #glrCharacter.Lottery.Entries.TicketNumbers[v] do
			table.insert(ticketNumbersTable, glrCharacter.Lottery.Entries.TicketNumbers[v][i])
		end
	end
	
	for t, v in pairs(glrCharacter.Lottery.TicketPool) do
		table.insert(ticketPool, v)
	end
	
	for i = 1, #ticketNumbersTable do
		if ticketNumbersTable[i] == winningTicket then
			for t, v in pairs(glrCharacter.Lottery.Entries.Names) do
				for j = 1, #glrCharacter.Lottery.Entries.TicketNumbers[v] do
					local tn = glrCharacter.Lottery.Entries.TicketNumbers[v][j]
					if tn == winningTicket then
						if not glrAbortRoll then
							C_Timer.After(1, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
							C_Timer.After(2, function(self) SendChatMessage(L["Lottery Draw Step 6 Announce Second Place Winning Ticket"] .. winningTicket, "GUILD") end)
							C_Timer.After(3, function(self) SendChatMessage(L["Lottery Draw Step 6 Winner Found Part 1"] .. v .. L["Lottery Draw Step 6 Winner Found Part 2"] .. secondPercent .. L["Lottery Draw Step 6 Winner Found Part 3"], "GUILD") end)
							C_Timer.After(4, function(self) SendChatMessage(L["Lottery Draw Step 6 Guilds Take Part 1"] .. guildPercent .. L["Lottery Draw Step 6 Guilds Take Part 2"], "GUILD") end)
							C_Timer.After(5, function(self) SendChatMessage(L["Lottery Draw Step 6 Next Lottery Starts Part 1"] .. remainingJackpot .. L["Lottery Draw Step 6 Next Lottery Starts Part 2"], "GUILD") end)
							C_Timer.After(6, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
							lotteryCompleted = true
							winnerFound = true
							prepareNext = true
						elseif glrAbortRoll and not abortPrinted then
							SendChatMessage(L["Abort Roll Message"], "GUILD")
							glrLotteryDrawInProgress = false
							abortPrinted = true
						end
					end
				end
			end
		end
	end
	
	if not winnerFound then
		for i = 1, #ticketPool do --If the winning ticket number wasn't assigned to a person, it redoes the ticket draw.
			if ticketPool[i] == winningTicket then
				if not glrAbortRoll then
					C_Timer.After(1, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
					C_Timer.After(2, function(self) SendChatMessage(L["Lottery Draw Step 6 Unused Ticket Found Part 1"] .. winningTicket .. L["Lottery Draw Step 6 Unused Ticket Found Part 2"], "GUILD") end)
					C_Timer.After(3, function(self) SendChatMessage(L["Lottery Draw Step 6 Unused Ticket Redraw"], "GUILD") end)
					C_Timer.After(13, BeginLotteryDrawStep6)
					winnerFound = true
				elseif glrAbortRoll and not abortPrinted then
					C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
					glrLotteryDrawInProgress = false
					abortPrinted = true
				end
			end
		end
	end
	
	if not winnerFound then
		if not glrAbortRoll then
			remainingJackpot = jackpotGold - guildPercent
			C_Timer.After(1, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
			C_Timer.After(2, function(self) SendChatMessage(L["Lottery Draw Step 6 No Winner Found"] .. winningTicket, "GUILD") end)
			C_Timer.After(3, function(self) SendChatMessage(L["Lottery Draw Step 6 No Second Place Part 1"] .. remainingJackpot .. L["Lottery Draw Step 6 No Second Place Part 2"], "GUILD") end)
			C_Timer.After(4, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
			lotteryCompleted = true
			prepareNext = true
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrLotteryDrawInProgress = false
			abortPrinted = true
		end
	end
	
	if prepareNext then
		if not glrAbortRoll then
			LotteryCompletionBuffer()
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrLotteryDrawInProgress = false
			abortPrinted = true
		end
	end
	
end

local function BeginLotteryDrawStep6Buffer(winningTicket)
	
	local jackpotGold = tonumber(glrCharacter.Event["Lottery"]["StartingGold"]) + ( glrCharacter.Event["Lottery"]["TicketsSold"] * tonumber(glrCharacter.Event["Lottery"]["TicketPrice"]) )
	local guildPercent = (tonumber(glrCharacter.Event.Lottery.GuildCut) / 100) * jackpotGold
	local winnerFound = false
	local prepareNext = false
	local bypass = false
	local ticketNumbersTable = {}
	local secondPercent = 1
	if tonumber(glrCharacter.Event.Lottery.SecondPlace) ~= nil then
		secondPercent = tonumber(glrCharacter.Event.Lottery.SecondPlace)
	end
	if glrCharacter.Event.Lottery.SecondPlace ~= L["Winner Guaranteed"] then
		if tonumber(glrCharacter.Event.Lottery.SecondPlace) == 0 then
			bypass = true -- Since Second Place is 0% of the Jackpot, why attempt a draw for it?
		end
	elseif glrCharacter.Event.Lottery.SecondPlace == L["Winner Guaranteed"] then
		winnerFound = true --Prevents the mod from attempting to draw a second place ticket since a winner is guaranteed
	end
	
	for t, v in pairs(glrCharacter.Lottery.Entries.Names) do
		for i = 1, #glrCharacter.Lottery.Entries.TicketNumbers[v] do
			table.insert(ticketNumbersTable, glrCharacter.Lottery.Entries.TicketNumbers[v][i])
		end
	end
	
	sort(ticketNumbersTable)
	
	if secondPercent > 0 then
		for i = 1, #ticketNumbersTable do
			if ticketNumbersTable[i] == winningTicket then
				for t, v in pairs(glrCharacter.Lottery.Entries.Names) do
					for j = 1, #glrCharacter.Lottery.Entries.TicketNumbers[v] do
						local tn = glrCharacter.Lottery.Entries.TicketNumbers[v][j]
						if tn == winningTicket then
							if not glrAbortRoll then
								C_Timer.After(1, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
								C_Timer.After(2, function(self) SendChatMessage(L["Lottery Draw Step 5 Announce Winning Ticket"] .. winningTicket, "GUILD") end)
								C_Timer.After(3, function(self) SendChatMessage(L["Lottery Draw Step 5 Winner Found Part 1"] .. v .. L["Lottery Draw Step 5 Winner Found Part 2"] .. remainingJackpot .. L["Lottery Draw Step 5 Winner Found Part 3"], "GUILD") end)
								C_Timer.After(4, function(self) SendChatMessage(L["Lottery Draw Step 5 Guilds Take Part 1"] .. guildPercent .. L["Lottery Draw Step 5 Guilds Take Part 2"], "GUILD") end)
								C_Timer.After(5, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
								clearPreviousJackpot = true
								lotteryWinnerFound = true
								winnerFound = true
								prepareNext = true
							elseif glrAbortRoll and not abortPrinted then
								C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
								glrLotteryDrawInProgress = false
								abortPrinted = true
							end
						end
					end
				end
			end
		end
	end
	
	if not winnerFound and secondPercent == 0 then --Only does this if no Winner Guaranteed, Second Place % is zero
		if not glrAbortRoll then
			for i = 1, #ticketNumbersTable do
				if ticketNumbersTable[i] == winningTicket then
					for t, v in pairs(glrCharacter.Lottery.Entries.Names) do
						for j = 1, #glrCharacter.Lottery.Entries.TicketNumbers[v] do
							local tn = glrCharacter.Lottery.Entries.TicketNumbers[v][j]
							if tn == winningTicket then
								C_Timer.After(1, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
								C_Timer.After(2, function(self) SendChatMessage(L["Lottery Draw Step 5 Announce Winning Ticket"] .. winningTicket, "GUILD") end)
								C_Timer.After(3, function(self) SendChatMessage(L["Lottery Draw Step 5 Winner Found Part 1"] .. v .. L["Lottery Draw Step 5 Winner Found Part 2"] .. remainingJackpot .. L["Lottery Draw Step 5 Winner Found Part 3"], "GUILD") end)
								C_Timer.After(4, function(self) SendChatMessage(L["Lottery Draw Step 5 Guilds Take Part 1"] .. guildPercent .. L["Lottery Draw Step 5 Guilds Take Part 2"], "GUILD") end)
								C_Timer.After(5, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
								clearPreviousJackpot = true
								lotteryWinnerFound = true
								winnerFound = true
								prepareNext = true
							end
						end
					end
				end
			end
			if not lotteryWinnerFound then
				C_Timer.After(1, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
				C_Timer.After(2, function(self) SendChatMessage(L["Lottery Draw Step 5 No Winner Found"] .. winningTicket, "GUILD") end)
				C_Timer.After(3, function(self) SendChatMessage(L["Lottery Draw Step 5 Guilds Take Part 1"] .. guildPercent .. L["Lottery Draw Step 5 Guilds Take Part 2"], "GUILD") end)
				C_Timer.After(4, function(self) SendChatMessage(L["Lottery Draw Step 6 Next Lottery Starts Part 1"] .. remainingJackpot .. L["Lottery Draw Step 6 Next Lottery Starts Part 2"], "GUILD") end)
				lotteryWinnerFound = true
				winnerFound = true
				prepareNext = true
			end
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrLotteryDrawInProgress = false
			abortPrinted = true
		end
	end
	
	if not winnerFound then --Only does this if no one won the Jackpot but someone can win Second Place.
		if not bypass then
			if not glrAbortRoll then
				C_Timer.After(6, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
				C_Timer.After(7, function(self) SendChatMessage(L["Lottery Draw Step 5 No Winner Found"] .. winningTicket, "GUILD") end)
				C_Timer.After(8, function(self) SendChatMessage(L["Lottery Draw Step 5 Draw Second Place"], "GUILD") end)
				C_Timer.After(18, BeginLotteryDrawStep6)
			elseif glrAbortRoll and not abortPrinted then
				C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
				glrLotteryDrawInProgress = false
				abortPrinted = true
			end
		end
	end
	
	if prepareNext then
		if not glrAbortRoll then
			LotteryCompletionBuffer()
		elseif glrAbortRoll and not abortPrinted then
			C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
			glrLotteryDrawInProgress = false
			abortPrinted = true
		end
	end
end

local function BeginLotteryDrawStep5()
	
	local firstTicket = glrCharacter.Event.Lottery.FirstTicketNumber
	local lastTicket = glrCharacter.Event.Lottery.LastTicketBought - 1
	local ticketPool = {}
	local secondPercent = 1
	local continue = false
	local ticketNotFound = true
	local count = 0
	if tonumber(glrCharacter.Event.Lottery.SecondPlace) ~= nil then
		secondPercent = tonumber(glrCharacter.Event.Lottery.SecondPlace)
	end
	if glrCharacter.Event.Lottery.SecondPlace ~= L["Winner Guaranteed"] then
		lastTicket = glrCharacter.Event.Lottery.LastTicketBought - 2
	end
	local winningTicket = tostring(math.random(firstTicket, lastTicket))
	
	for t, v in pairs(glrCharacter.Lottery.TicketPool) do
		table.insert(ticketPool, v)
		count = count + 1
	end
	
	if count == 0 then
		continue = true
	end
	
	if count >= 1 then
		for i = 1, #ticketPool do --If the winning ticket number wasn't assigned to a person, it redoes the ticket draw.
			count = count - 1
			if ticketPool[i] == winningTicket then
				if not glrAbortRoll then
					C_Timer.After(0.2, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
					C_Timer.After(0.4, function(self) SendChatMessage(L["Lottery Draw Step 5 Unused Ticket Found Part 1"] .. winningTicket .. L["Lottery Draw Step 5 Unused Ticket Found Part 2"], "GUILD") end)
					C_Timer.After(0.6, function(self) SendChatMessage(L["Lottery Draw Step 5 Unused Ticket Redraw"], "GUILD") end)
					ticketNotFound = false
					C_Timer.After(10, BeginLotteryDrawStep5)
				elseif glrAbortRoll and not abortPrinted then
					C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
					glrLotteryDrawInProgress = false
					abortPrinted = true
				end
			end
			if count == 0 then
				continue = true
			end
		end
	end
	
	if count == 0 and continue and ticketNotFound then
		BeginLotteryDrawStep6Buffer(winningTicket)
	end
end

local function BeginLotteryDrawStep4()
	
	local secondPercent = glrCharacter.Event.Lottery.SecondPlace
	local jackpotGold = tonumber(glrCharacter.Event["Lottery"]["StartingGold"]) + ( glrCharacter.Event["Lottery"]["TicketsSold"] * tonumber(glrCharacter.Event["Lottery"]["TicketPrice"]) )
	local guildPercent = (tonumber(glrCharacter.Event.Lottery.GuildCut) / 100) * jackpotGold
	remainingJackpot = jackpotGold - guildPercent
	
	if secondPercent ~= L["Winner Guaranteed"] then
		secondPercent = (tonumber(secondPercent) / 100) * jackpotGold
	end
	
	if secondPercent == L["Winner Guaranteed"] and guildPercent > 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 4 Condition 1 Part 1"] .. guildPercent .. L["Lottery Draw Step 4 Condition 1 Part 2"] .. remainingJackpot .. L["Lottery Draw Step 4 Fixed Variable 1"], "GUILD") end)
	elseif secondPercent ~= L["Winner Guaranteed"] and guildPercent == 0 and secondPercent > 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 4 Fixed Variable 2"] .. remainingJackpot .. L["Lottery Draw Step 4 Fixed Variable 3"] .. secondPercent .. L["Lottery Draw Step 4 Fixed Variable 1"], "GUILD") end)
	elseif secondPercent ~= L["Winner Guaranteed"] and guildPercent > 0 and secondPercent > 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 4 Fixed Variable 2"] .. remainingJackpot .. L["Lottery Draw Step 4 Fixed Variable 3"] .. secondPercent .. L["Lottery Draw Step 4 Fixed Variable 1"], "GUILD") end)
	end
	
	if not glrAbortRoll then
		C_Timer.After(0.4, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
		C_Timer.After(0.6, function(self) SendChatMessage(L["Lottery Draw Step 4 Announce Roll"], "GUILD") end)
		C_Timer.After(10.6, BeginLotteryDrawStep5)
	elseif glrAbortRoll and not abortPrinted then
		C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
		glrLotteryDrawInProgress = false
		abortPrinted = true
	end
	
end

local function BeginLotteryDrawStep3()
	
	local guildPercent = tonumber(glrCharacter.Event.Lottery.GuildCut)
	local secondPercent = glrCharacter.Event.Lottery.SecondPlace
	
	if secondPercent ~= L["Winner Guaranteed"] then
		secondPercent = tonumber(secondPercent)
	end
	
	if secondPercent == L["Winner Guaranteed"] and guildPercent > 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 3 Condition 1"] .. guildPercent .. L["Lottery Draw Step 3 Fixed Variable 1"], "GUILD") end)
	elseif secondPercent == L["Winner Guaranteed"] and guildPercent == 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 3 Condition 2"], "GUILD") end)
	elseif secondPercent ~= L["Winner Guaranteed"] and guildPercent > 0 and secondPercent > 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 3 Condition 3 Guild Part"] .. guildPercent .. L["Lottery Draw Step 3 Fixed Variable 1"], "GUILD") end)
		C_Timer.After(0.4, function(self) SendChatMessage(L["Lottery Draw Step 3 Condition 3"] .. secondPercent .. L["Lottery Draw Step 3 Fixed Variable 1"], "GUILD") end)
	elseif secondPercent ~= L["Winner Guaranteed"] and guildPercent == 0 and secondPercent == 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 3 Fixed Variable 3"], "GUILD") end)
		C_Timer.After(0.4, function(self) SendChatMessage(L["Lottery Draw Step 3 Fixed Variable 2"], "GUILD") end)
	elseif secondPercent ~= L["Winner Guaranteed"] and guildPercent == 0 and secondPercent > 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 3 Fixed Variable 3"], "GUILD") end)
		C_Timer.After(0.4, function(self) SendChatMessage(L["Lottery Draw Step 3 Condition 3"] .. secondPercent .. L["Lottery Draw Step 3 Fixed Variable 1"], "GUILD") end)
	elseif secondPercent ~= L["Winner Guaranteed"] and guildPercent > 0 and secondPercent == 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 3 Condition 3 Guild Part"] .. guildPercent .. L["Lottery Draw Step 3 Fixed Variable 1"], "GUILD") end)
		C_Timer.After(0.4, function(self) SendChatMessage(L["Lottery Draw Step 3 Fixed Variable 2"], "GUILD") end)
	end
	
	if not glrAbortRoll then
		C_Timer.After(12, BeginLotteryDrawStep4)
	elseif glrAbortRoll and not abortPrinted then
		C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
		glrLotteryDrawInProgress = false
		abortPrinted = true
	end
	
end

local function BeginLotteryDrawStep2()
	
	local ticketPool = {}
	local numberOfInvalidTickets = 0
	local lowestTicketNumber = glrCharacter.Event.Lottery.FirstTicketNumber
	local highestTicketNumber = glrCharacter.Event.Lottery.LastTicketBought - 1
	if glrCharacter.Event.Lottery.SecondPlace ~= L["Winner Guaranteed"] then
		highestTicketNumber = glrCharacter.Event.Lottery.LastTicketBought - 2
	end
	
	if glrCharacter.Lottery.TicketPool ~= nil then
		for t, v in pairs(glrCharacter.Lottery.TicketPool) do
			numberOfInvalidTickets = numberOfInvalidTickets + 1
		end
	end
	
	if numberOfInvalidTickets > 0 then
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 2 Invalid Tickets Part 1"] .. numberOfInvalidTickets .. L["Lottery Draw Step 2 Invalid Tickets Part 2"], "GUILD") end)
		C_Timer.After(0.4, function(self) SendChatMessage(L["Lottery Draw Step 2 Part 1"] .. ": " .. lowestTicketNumber .. " " .. L["Lottery Draw Step 2 Part 2"] .. " " .. highestTicketNumber .. ".", "GUILD") end)
	else
		C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 2 Part 1"] .. ": " .. lowestTicketNumber .. " " .. L["Lottery Draw Step 2 Part 2"] .. " " .. highestTicketNumber .. ".", "GUILD") end)
	end
	
	if not glrAbortRoll then
		C_Timer.After(12, BeginLotteryDrawStep3)
	elseif glrAbortRoll and not abortPrinted then
		C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
		glrLotteryDrawInProgress = false
		abortPrinted = true
	end
	
end

local function BeginLotteryDrawStep1()
	
	local jackpotGold = tostring(tonumber(glrCharacter.Event["Lottery"]["StartingGold"]) + ( glrCharacter.Event["Lottery"]["TicketsSold"] * tonumber(glrCharacter.Event["Lottery"]["TicketPrice"]) ))
	local numberOfTickets = glrCharacter.Event.Lottery.TicketsSold
	
	C_Timer.After(0.2, function(self) SendChatMessage(L["Lottery Draw Step 1 Part 1"] .. " " .. numberOfTickets .. " " .. L["Lottery Draw Step 1 Part 2"] .. ": " .. jackpotGold .. " " .. L["Lottery Draw Step 1 Part 3"], "GUILD") end)
	
	if glrCharacter.Event.Lottery.GiveAwayTickets ~= nil then
		if glrCharacter.Event.Lottery.GiveAwayTickets > 0 then
			local GivenTickets = tostring(glrCharacter.Event.Lottery.GiveAwayTickets)
			C_Timer.After(0.4, function(self) SendChatMessage(L["Send Info GLR"] .. ": " .. GivenTickets .. " " .. L["Draw Given Tickets"], "GUILD") end)
		end
	end
	
	if not glrAbortRoll then
		C_Timer.After(12, BeginLotteryDrawStep2)
	elseif glrAbortRoll and not abortPrinted then
		C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
		glrLotteryDrawInProgress = false
		abortPrinted = true
	end
	
end

local function InitiateLotteryRoll()
	
	local lotteryStatus = glrCharacter.Data.Settings["CurrentlyActiveLottery"]
	lotteryWinnerFound = false
	clearPreviousJackpot = false
	glrAbortRoll = false
	abortPrinted = false
	remainingJackpot = 0
	
	if not glrAbortRoll then
		if lotteryStatus and glrCharacter.Event.Lottery ~= nil then --Prevents starting a non-existent lottery draw
			if glrCharacter.Event.Lottery.TicketsSold >= 1 then
				GLR_UI.GLR_MainFrame.GLR_AbortRollProcessButton:Show()
				glrLotteryDrawInProgress = true --Prevents a lottery draw from occuring while one's in progress
				C_Timer.After(0.2, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
				C_Timer.After(0.4, function(self) SendChatMessage(L["GLR Title with Version"] .. GLR_Version, "GUILD") end)
				C_Timer.After(0.6, function(self) SendChatMessage(L["Begin Lottery Draw"], "GUILD") end)
				C_Timer.After(0.8, function(self) SendChatMessage("--------------------------------------------------", "GUILD") end)
				C_Timer.After(15, BeginLotteryDrawStep1)
			end
		else
			GLR:Print(L["No Lottery Active"])
		end
	elseif glrAbortRoll and not abortPrinted then
		C_Timer.After(1, function(self) SendChatMessage(L["Abort Roll Message"], "GUILD") end)
		glrLotteryDrawInProgress = false
		abortPrinted = true
	end
	
end

--Confirm Start Raffle Roll Button Settings
local GLR_StartRaffleButton = CreateFrame("Button", "GLR_StartRaffleButton", GLR_UI.GLR_MainFrame.GLR_ConfirmStartRaffleBorder, "GameMenuButtonTemplate")
GLR_StartRaffleButton:SetPoint("CENTER", GLR_UI.GLR_MainFrame.GLR_ConfirmStartRaffleBorder, "CENTER")
GLR_StartRaffleButton:SetSize(100, 26)
GLR_StartRaffleButton:SetScript("OnClick", function(self)
	InitiateRaffleRoll()
	GLR_UI.GLR_MainFrame.GLR_ConfirmStartRaffleBorder:Hide()
end)
GLR_StartRaffleButton:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_LEFT")
	GameTooltip:SetText(L["GLR Tooltip Title"], 0.97, 1, 0.30)
	GameTooltip:AddLine(L["Confirm Start Raffle Button Tooltip"])
	GameTooltip:AddLine(L["Confirm Start Raffle Button Tooltip Warning"], 1, 0, 0)
	GameTooltip:Show()
end)
GLR_StartRaffleButton:SetScript("OnLeave", function(self)
	GameTooltip:Hide()
end)

--Confirm Start Lottery Roll Button Settings
local GLR_StartLotteryButton = CreateFrame("Button", "GLR_StartLotteryButton", GLR_UI.GLR_MainFrame.GLR_ConfirmStartLotteryBorder, "GameMenuButtonTemplate")
GLR_StartLotteryButton:SetPoint("CENTER", GLR_UI.GLR_MainFrame.GLR_ConfirmStartLotteryBorder, "CENTER")
GLR_StartLotteryButton:SetSize(100, 26)
GLR_StartLotteryButton:SetScript("OnClick", function(self)
	InitiateLotteryRoll()
	GLR_UI.GLR_MainFrame.GLR_ConfirmStartLotteryBorder:Hide()
end)
GLR_StartLotteryButton:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_LEFT")
	GameTooltip:SetText(L["GLR Tooltip Title"], 0.97, 1, 0.30)
	GameTooltip:AddLine(L["Confirm Start Lottery Button Tooltip"])
	GameTooltip:AddLine(L["Confirm Start Lottery Button Tooltip Warning"], 1, 0, 0)
	GameTooltip:Show()
end)
GLR_StartLotteryButton:SetScript("OnLeave", function(self)
	GameTooltip:Hide()
end)

--Confirm Start Raffle Roll Button String & Settings
local GLR_StartRaffleButtonText = GLR_StartRaffleButton:CreateFontString("GLR_StartRaffleButtonText", "OVERLAY", "GameFontWhiteTiny")
GLR_StartRaffleButtonText:SetPoint("CENTER", GLR_StartRaffleButton)
GLR_StartRaffleButtonText:SetText(L["Confirm Start Button"])
GLR_StartRaffleButtonText:SetFont(GLR_UI.ButtonFont, 11)

--Confirm Start Lottery Roll Button String & Settings
local GLR_StartLotteryButtonText = GLR_StartLotteryButton:CreateFontString("GLR_StartLotteryButtonText", "OVERLAY", "GameFontWhiteTiny")
GLR_StartLotteryButtonText:SetPoint("CENTER", GLR_StartLotteryButton)
GLR_StartLotteryButtonText:SetText(L["Confirm Start Button"])
GLR_StartLotteryButtonText:SetFont(GLR_UI.ButtonFont, 11)

local function CheckLocale()
	locale = GetLocale()
	if locale == nil then
		C_Timer.After(1, CheckLocale)
	else
		if locale == "frFR" then
			GLR_StartLotteryButton:SetSize(135, 26)
			GLR_StartRaffleButton:SetSize(135, 26)
		end
	end
end

if locale == nil then
	CheckLocale()
else
	if locale == "frFR" then
		GLR_StartLotteryButton:SetSize(135, 26)
		GLR_StartRaffleButton:SetSize(135, 26)
	end
end